/* Icon.c generated by valac 0.45.3, the Vala compiler
 * generated from Icon.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define NOISE_TYPE_ICON (noise_icon_get_type ())
#define NOISE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ICON, NoiseIcon))
#define NOISE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ICON, NoiseIconClass))
#define NOISE_IS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ICON))
#define NOISE_IS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ICON))
#define NOISE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ICON, NoiseIconClass))

typedef struct _NoiseIcon NoiseIcon;
typedef struct _NoiseIconClass NoiseIconClass;
typedef struct _NoiseIconPrivate NoiseIconPrivate;
enum  {
	NOISE_ICON_0_PROPERTY,
	NOISE_ICON_NAME_PROPERTY,
	NOISE_ICON_GICON_PROPERTY,
	NOISE_ICON_NUM_PROPERTIES
};
static GParamSpec* noise_icon_properties[NOISE_ICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseIcon {
	GObject parent_instance;
	NoiseIconPrivate * priv;
};

struct _NoiseIconClass {
	GObjectClass parent_class;
};

struct _NoiseIconPrivate {
	gchar* _name;
	GIcon* _gicon;
};

static gint NoiseIcon_private_offset;
static gpointer noise_icon_parent_class = NULL;
static GtkIconTheme* noise_icon__theme;
static GtkIconTheme* noise_icon__theme = NULL;

GType noise_icon_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseIcon, g_object_unref)
NoiseIcon* noise_icon_new (const gchar* name);
NoiseIcon* noise_icon_construct (GType object_type,
                                 const gchar* name);
static void noise_icon_set_name (NoiseIcon* self,
                          const gchar* value);
const gchar* noise_icon_get_name (NoiseIcon* self);
static void noise_icon_set_gicon (NoiseIcon* self,
                           GIcon* value);
GtkIconInfo* noise_icon_get_icon_info (NoiseIcon* self,
                                       gint size);
GtkIconTheme* noise_icon_get_theme (void);
GIcon* noise_icon_get_gicon (NoiseIcon* self);
GFile* noise_icon_get_file (NoiseIcon* self,
                            gint size);
GdkPixbuf* noise_icon_render (NoiseIcon* self,
                              GtkIconSize size,
                              GtkStyleContext* style_context);
static void noise_icon_finalize (GObject * obj);
static void _vala_noise_icon_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_noise_icon_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
noise_icon_get_instance_private (NoiseIcon* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseIcon_private_offset);
}

/**
     * Creates a new icon object.
     *
     * @param name The icon name (without filename extension), to be loaded from
     * the available icon themes.
     */
NoiseIcon*
noise_icon_construct (GType object_type,
                      const gchar* name)
{
	NoiseIcon * self = NULL;
	const gchar* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
#line 58 "../core/Utils/Icon.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 58 "../core/Utils/Icon.vala"
	self = (NoiseIcon*) g_object_new (object_type, NULL);
#line 59 "../core/Utils/Icon.vala"
	noise_icon_set_name (self, name);
#line 60 "../core/Utils/Icon.vala"
	_tmp0_ = self->priv->_name;
#line 60 "../core/Utils/Icon.vala"
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
#line 60 "../core/Utils/Icon.vala"
	_tmp2_ = _tmp1_;
#line 60 "../core/Utils/Icon.vala"
	noise_icon_set_gicon (self, (GIcon*) _tmp2_);
#line 60 "../core/Utils/Icon.vala"
	_g_object_unref0 (_tmp2_);
#line 58 "../core/Utils/Icon.vala"
	return self;
#line 148 "Icon.c"
}

NoiseIcon*
noise_icon_new (const gchar* name)
{
#line 58 "../core/Utils/Icon.vala"
	return noise_icon_construct (NOISE_TYPE_ICON, name);
#line 156 "Icon.c"
}

GtkIconInfo*
noise_icon_get_icon_info (NoiseIcon* self,
                          gint size)
{
	GtkIconInfo* result = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GIcon* _tmp2_;
	GtkIconInfo* _tmp3_;
#line 63 "../core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../core/Utils/Icon.vala"
	_tmp0_ = noise_icon_get_theme ();
#line 64 "../core/Utils/Icon.vala"
	_tmp1_ = _tmp0_;
#line 64 "../core/Utils/Icon.vala"
	_tmp2_ = self->priv->_gicon;
#line 64 "../core/Utils/Icon.vala"
	_tmp3_ = gtk_icon_theme_lookup_by_gicon (_tmp1_, _tmp2_, size, GTK_ICON_LOOKUP_USE_BUILTIN);
#line 64 "../core/Utils/Icon.vala"
	result = _tmp3_;
#line 64 "../core/Utils/Icon.vala"
	return result;
#line 182 "Icon.c"
}

/**
     * Returns a file representing the icon in the filesystem.
     * @param size Icon size to query.
     * @return A {@link GLib.File} representing the icon, or //null// if none is found.
     */
GFile*
noise_icon_get_file (NoiseIcon* self,
                     gint size)
{
	GFile* result = NULL;
	GtkIconInfo* info = NULL;
	GtkIconInfo* _tmp0_;
	GFile* _tmp1_ = NULL;
	GtkIconInfo* _tmp2_;
#line 72 "../core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../core/Utils/Icon.vala"
	_tmp0_ = noise_icon_get_icon_info (self, size);
#line 73 "../core/Utils/Icon.vala"
	info = _tmp0_;
#line 74 "../core/Utils/Icon.vala"
	_tmp2_ = info;
#line 74 "../core/Utils/Icon.vala"
	if (_tmp2_ != NULL) {
#line 209 "Icon.c"
		GtkIconInfo* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
#line 74 "../core/Utils/Icon.vala"
		_tmp3_ = info;
#line 74 "../core/Utils/Icon.vala"
		_tmp4_ = gtk_icon_info_get_filename (_tmp3_);
#line 74 "../core/Utils/Icon.vala"
		_tmp5_ = g_file_new_for_path (_tmp4_);
#line 74 "../core/Utils/Icon.vala"
		_g_object_unref0 (_tmp1_);
#line 74 "../core/Utils/Icon.vala"
		_tmp1_ = _tmp5_;
#line 223 "Icon.c"
	} else {
#line 74 "../core/Utils/Icon.vala"
		_g_object_unref0 (_tmp1_);
#line 74 "../core/Utils/Icon.vala"
		_tmp1_ = NULL;
#line 229 "Icon.c"
	}
#line 74 "../core/Utils/Icon.vala"
	result = _tmp1_;
#line 74 "../core/Utils/Icon.vala"
	_g_object_unref0 (info);
#line 74 "../core/Utils/Icon.vala"
	return result;
#line 237 "Icon.c"
}

/**
     * Creates a new {@link Gdk.Pixbuf} from the icon at the specified icon size.
     *
     * @param size The pixbuf's icon size.
     * @param style_context The style context used to render the icon, or null to use none.
     * @return a newly-created Gdk.Pixbuf displaying the icon (or a "missing-image" icon)
     */
GdkPixbuf*
noise_icon_render (NoiseIcon* self,
                   GtkIconSize size,
                   GtkStyleContext* style_context)
{
	GdkPixbuf* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint pixel_size = 0;
	GdkPixbuf* rv = NULL;
	GError* _inner_error0_ = NULL;
#line 84 "../core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../core/Utils/Icon.vala"
	gtk_icon_size_lookup (size, &_tmp0_, &_tmp1_);
#line 86 "../core/Utils/Icon.vala"
	width = _tmp0_;
#line 86 "../core/Utils/Icon.vala"
	height = _tmp1_;
#line 87 "../core/Utils/Icon.vala"
	pixel_size = MAX (width, height);
#line 88 "../core/Utils/Icon.vala"
	rv = NULL;
#line 272 "Icon.c"
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconInfo* _tmp2_;
		GtkIconInfo* _tmp3_;
		GdkPixbuf* _tmp12_;
#line 91 "../core/Utils/Icon.vala"
		_tmp2_ = noise_icon_get_icon_info (self, pixel_size);
#line 91 "../core/Utils/Icon.vala"
		icon_info = _tmp2_;
#line 93 "../core/Utils/Icon.vala"
		_tmp3_ = icon_info;
#line 93 "../core/Utils/Icon.vala"
		if (_tmp3_ != NULL) {
#line 94 "../core/Utils/Icon.vala"
			if (style_context != NULL) {
#line 288 "Icon.c"
				GdkPixbuf* _tmp4_ = NULL;
				GtkIconInfo* _tmp5_;
				GdkPixbuf* _tmp6_;
				GdkPixbuf* _tmp7_;
#line 95 "../core/Utils/Icon.vala"
				_tmp5_ = icon_info;
#line 95 "../core/Utils/Icon.vala"
				_tmp6_ = gtk_icon_info_load_symbolic_for_context (_tmp5_, style_context, NULL, &_inner_error0_);
#line 95 "../core/Utils/Icon.vala"
				_tmp4_ = _tmp6_;
#line 95 "../core/Utils/Icon.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../core/Utils/Icon.vala"
					_g_object_unref0 (icon_info);
#line 303 "Icon.c"
					goto __catch13_g_error;
				}
#line 95 "../core/Utils/Icon.vala"
				_tmp7_ = _tmp4_;
#line 95 "../core/Utils/Icon.vala"
				_tmp4_ = NULL;
#line 95 "../core/Utils/Icon.vala"
				_g_object_unref0 (rv);
#line 95 "../core/Utils/Icon.vala"
				rv = _tmp7_;
#line 94 "../core/Utils/Icon.vala"
				_g_object_unref0 (_tmp4_);
#line 316 "Icon.c"
			} else {
				GdkPixbuf* _tmp8_ = NULL;
				GtkIconInfo* _tmp9_;
				GdkPixbuf* _tmp10_;
				GdkPixbuf* _tmp11_;
#line 97 "../core/Utils/Icon.vala"
				_tmp9_ = icon_info;
#line 97 "../core/Utils/Icon.vala"
				_tmp10_ = gtk_icon_info_load_icon (_tmp9_, &_inner_error0_);
#line 97 "../core/Utils/Icon.vala"
				_tmp8_ = _tmp10_;
#line 97 "../core/Utils/Icon.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../core/Utils/Icon.vala"
					_g_object_unref0 (icon_info);
#line 332 "Icon.c"
					goto __catch13_g_error;
				}
#line 97 "../core/Utils/Icon.vala"
				_tmp11_ = _tmp8_;
#line 97 "../core/Utils/Icon.vala"
				_tmp8_ = NULL;
#line 97 "../core/Utils/Icon.vala"
				_g_object_unref0 (rv);
#line 97 "../core/Utils/Icon.vala"
				rv = _tmp11_;
#line 94 "../core/Utils/Icon.vala"
				_g_object_unref0 (_tmp8_);
#line 345 "Icon.c"
			}
		}
#line 102 "../core/Utils/Icon.vala"
		_tmp12_ = rv;
#line 102 "../core/Utils/Icon.vala"
		if (_tmp12_ == NULL) {
#line 352 "Icon.c"
			const gchar* _tmp13_;
			GdkPixbuf* _tmp14_ = NULL;
			GtkIconTheme* _tmp15_;
			GtkIconTheme* _tmp16_;
			GdkPixbuf* _tmp17_;
			GdkPixbuf* _tmp18_;
#line 103 "../core/Utils/Icon.vala"
			_tmp13_ = self->priv->_name;
#line 103 "../core/Utils/Icon.vala"
			g_warning ("Icon.vala:103: Icon not found: %s", _tmp13_);
#line 104 "../core/Utils/Icon.vala"
			_tmp15_ = noise_icon_get_theme ();
#line 104 "../core/Utils/Icon.vala"
			_tmp16_ = _tmp15_;
#line 104 "../core/Utils/Icon.vala"
			_tmp17_ = gtk_icon_theme_load_icon (_tmp16_, "image-missing", pixel_size, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error0_);
#line 104 "../core/Utils/Icon.vala"
			_tmp14_ = _tmp17_;
#line 104 "../core/Utils/Icon.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../core/Utils/Icon.vala"
				_g_object_unref0 (icon_info);
#line 375 "Icon.c"
				goto __catch13_g_error;
			}
#line 104 "../core/Utils/Icon.vala"
			_tmp18_ = _tmp14_;
#line 104 "../core/Utils/Icon.vala"
			_tmp14_ = NULL;
#line 104 "../core/Utils/Icon.vala"
			_g_object_unref0 (rv);
#line 104 "../core/Utils/Icon.vala"
			rv = _tmp18_;
#line 102 "../core/Utils/Icon.vala"
			_g_object_unref0 (_tmp14_);
#line 388 "Icon.c"
		}
#line 90 "../core/Utils/Icon.vala"
		_g_object_unref0 (icon_info);
#line 392 "Icon.c"
	}
	goto __finally13;
	__catch13_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 90 "../core/Utils/Icon.vala"
		err = _inner_error0_;
#line 90 "../core/Utils/Icon.vala"
		_inner_error0_ = NULL;
#line 107 "../core/Utils/Icon.vala"
		_tmp19_ = self->priv->_name;
#line 107 "../core/Utils/Icon.vala"
		_tmp20_ = err;
#line 107 "../core/Utils/Icon.vala"
		_tmp21_ = _tmp20_->message;
#line 107 "../core/Utils/Icon.vala"
		g_warning ("Icon.vala:107: Could not load icon [%s]: %s", _tmp19_, _tmp21_);
#line 90 "../core/Utils/Icon.vala"
		_g_error_free0 (err);
#line 415 "Icon.c"
	}
	__finally13:
#line 90 "../core/Utils/Icon.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../core/Utils/Icon.vala"
		_g_object_unref0 (rv);
#line 90 "../core/Utils/Icon.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../core/Utils/Icon.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../core/Utils/Icon.vala"
		return NULL;
#line 428 "Icon.c"
	}
#line 110 "../core/Utils/Icon.vala"
	result = rv;
#line 110 "../core/Utils/Icon.vala"
	return result;
#line 434 "Icon.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../core/Utils/Icon.vala"
	return self ? g_object_ref (self) : NULL;
#line 442 "Icon.c"
}

GtkIconTheme*
noise_icon_get_theme (void)
{
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp3_;
#line 41 "../core/Utils/Icon.vala"
	_tmp0_ = noise_icon__theme;
#line 41 "../core/Utils/Icon.vala"
	if (_tmp0_ == NULL) {
#line 455 "Icon.c"
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
#line 42 "../core/Utils/Icon.vala"
		_tmp1_ = gtk_icon_theme_get_default ();
#line 42 "../core/Utils/Icon.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 42 "../core/Utils/Icon.vala"
		_g_object_unref0 (noise_icon__theme);
#line 42 "../core/Utils/Icon.vala"
		noise_icon__theme = _tmp2_;
#line 466 "Icon.c"
	}
#line 45 "../core/Utils/Icon.vala"
	_tmp3_ = noise_icon__theme;
#line 45 "../core/Utils/Icon.vala"
	result = _tmp3_;
#line 45 "../core/Utils/Icon.vala"
	return result;
#line 474 "Icon.c"
}

const gchar*
noise_icon_get_name (NoiseIcon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../core/Utils/Icon.vala"
	_tmp0_ = self->priv->_name;
#line 49 "../core/Utils/Icon.vala"
	result = _tmp0_;
#line 49 "../core/Utils/Icon.vala"
	return result;
#line 490 "Icon.c"
}

static void
noise_icon_set_name (NoiseIcon* self,
                     const gchar* value)
{
#line 49 "../core/Utils/Icon.vala"
	g_return_if_fail (self != NULL);
#line 49 "../core/Utils/Icon.vala"
	if (g_strcmp0 (value, noise_icon_get_name (self)) != 0) {
#line 501 "Icon.c"
		gchar* _tmp0_;
#line 49 "../core/Utils/Icon.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../core/Utils/Icon.vala"
		_g_free0 (self->priv->_name);
#line 49 "../core/Utils/Icon.vala"
		self->priv->_name = _tmp0_;
#line 49 "../core/Utils/Icon.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_NAME_PROPERTY]);
#line 511 "Icon.c"
	}
}

GIcon*
noise_icon_get_gicon (NoiseIcon* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 50 "../core/Utils/Icon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../core/Utils/Icon.vala"
	_tmp0_ = self->priv->_gicon;
#line 50 "../core/Utils/Icon.vala"
	result = _tmp0_;
#line 50 "../core/Utils/Icon.vala"
	return result;
#line 528 "Icon.c"
}

static void
noise_icon_set_gicon (NoiseIcon* self,
                      GIcon* value)
{
#line 50 "../core/Utils/Icon.vala"
	g_return_if_fail (self != NULL);
#line 50 "../core/Utils/Icon.vala"
	if (noise_icon_get_gicon (self) != value) {
#line 539 "Icon.c"
		GIcon* _tmp0_;
#line 50 "../core/Utils/Icon.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../core/Utils/Icon.vala"
		_g_object_unref0 (self->priv->_gicon);
#line 50 "../core/Utils/Icon.vala"
		self->priv->_gicon = _tmp0_;
#line 50 "../core/Utils/Icon.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_icon_properties[NOISE_ICON_GICON_PROPERTY]);
#line 549 "Icon.c"
	}
}

static void
noise_icon_class_init (NoiseIconClass * klass,
                       gpointer klass_data)
{
#line 37 "../core/Utils/Icon.vala"
	noise_icon_parent_class = g_type_class_peek_parent (klass);
#line 37 "../core/Utils/Icon.vala"
	g_type_class_adjust_private_offset (klass, &NoiseIcon_private_offset);
#line 37 "../core/Utils/Icon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_icon_get_property;
#line 37 "../core/Utils/Icon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_icon_set_property;
#line 37 "../core/Utils/Icon.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_icon_finalize;
#line 37 "../core/Utils/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_NAME_PROPERTY, noise_icon_properties[NOISE_ICON_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "../core/Utils/Icon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ICON_GICON_PROPERTY, noise_icon_properties[NOISE_ICON_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 571 "Icon.c"
}

static void
noise_icon_instance_init (NoiseIcon * self,
                          gpointer klass)
{
#line 37 "../core/Utils/Icon.vala"
	self->priv = noise_icon_get_instance_private (self);
#line 580 "Icon.c"
}

static void
noise_icon_finalize (GObject * obj)
{
	NoiseIcon * self;
#line 37 "../core/Utils/Icon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_ICON, NoiseIcon);
#line 49 "../core/Utils/Icon.vala"
	_g_free0 (self->priv->_name);
#line 50 "../core/Utils/Icon.vala"
	_g_object_unref0 (self->priv->_gicon);
#line 37 "../core/Utils/Icon.vala"
	G_OBJECT_CLASS (noise_icon_parent_class)->finalize (obj);
#line 595 "Icon.c"
}

/**
 * An Icon Object
 *
 * Icon objects point to icon files or generic icon names. The API provides convenience
 * methods for rendering the icon to a {@link Gdk.Pixbuf} image or {@link Gtk.Image} widgets.
 *
 * The icon is searched in the available icon themes.
 */
GType
noise_icon_get_type (void)
{
	static volatile gsize noise_icon_type_id__volatile = 0;
	if (g_once_init_enter (&noise_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseIcon), 0, (GInstanceInitFunc) noise_icon_instance_init, NULL };
		GType noise_icon_type_id;
		noise_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseIcon", &g_define_type_info, 0);
		NoiseIcon_private_offset = g_type_add_instance_private (noise_icon_type_id, sizeof (NoiseIconPrivate));
		g_once_init_leave (&noise_icon_type_id__volatile, noise_icon_type_id);
	}
	return noise_icon_type_id__volatile;
}

static void
_vala_noise_icon_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ICON, NoiseIcon);
#line 37 "../core/Utils/Icon.vala"
	switch (property_id) {
#line 37 "../core/Utils/Icon.vala"
		case NOISE_ICON_NAME_PROPERTY:
#line 37 "../core/Utils/Icon.vala"
		g_value_set_string (value, noise_icon_get_name (self));
#line 37 "../core/Utils/Icon.vala"
		break;
#line 37 "../core/Utils/Icon.vala"
		case NOISE_ICON_GICON_PROPERTY:
#line 37 "../core/Utils/Icon.vala"
		g_value_set_object (value, noise_icon_get_gicon (self));
#line 37 "../core/Utils/Icon.vala"
		break;
#line 642 "Icon.c"
		default:
#line 37 "../core/Utils/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../core/Utils/Icon.vala"
		break;
#line 648 "Icon.c"
	}
}

static void
_vala_noise_icon_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	NoiseIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ICON, NoiseIcon);
#line 37 "../core/Utils/Icon.vala"
	switch (property_id) {
#line 37 "../core/Utils/Icon.vala"
		case NOISE_ICON_NAME_PROPERTY:
#line 37 "../core/Utils/Icon.vala"
		noise_icon_set_name (self, g_value_get_string (value));
#line 37 "../core/Utils/Icon.vala"
		break;
#line 37 "../core/Utils/Icon.vala"
		case NOISE_ICON_GICON_PROPERTY:
#line 37 "../core/Utils/Icon.vala"
		noise_icon_set_gicon (self, g_value_get_object (value));
#line 37 "../core/Utils/Icon.vala"
		break;
#line 674 "Icon.c"
		default:
#line 37 "../core/Utils/Icon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../core/Utils/Icon.vala"
		break;
#line 680 "Icon.c"
	}
}

