/* PlaybackManager.c generated by valac 0.45.3, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
enum  {
	NOISE_PLAYBACK_MANAGER_0_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _NoisePlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	NoiseMedia* _current_media;
};

struct _Block10Data {
	int _ref_count_;
	NoisePlaybackManager* self;
	NoiseMedia* m;
};

static gint NoisePlaybackManager_private_offset;
static gpointer noise_playback_manager_parent_class = NULL;

GType noise_playback_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoisePlaybackManager, g_object_unref)
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseHistoryPlaylist, g_object_unref)
GType noise_streamer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseStreamer, g_object_unref)
void noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                          NoisePlayback* playback);
void noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                         GeeCollection* to_queue);
static void noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                            NoiseMedia* m);
static void noise_playback_manager_reshuffle (NoisePlaybackManager* self);
void noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                           GeeCollection* to_unqueue);
static NoiseMedia* noise_playback_manager_poll_queue (NoisePlaybackManager* self);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self);
void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                             NoiseSettingsRepeat mode);
void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                              NoiseSettingsShuffle mode);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_get_next (NoisePlaybackManager* self,
                                             gboolean play);
static NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self);
void noise_playback_manager_stop_playback (NoisePlaybackManager* self);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
NoiseMedia* noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                                 gboolean play);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                               NoiseMedia* value);
void noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                        gdouble value);
void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GSettings* noise_app_get_saved_state (void);
static gboolean __lambda33_ (Block10Data* _data10_);
static gboolean ___lambda33__gsource_func (gpointer self);
static void noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                         gboolean value);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NoiseLibraryWindow, g_object_unref)
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
#define NOISE_LIBRARY_WINDOW_ACTION_PLAY "action_play"
static GVariant* _variant_new4 (gboolean value);
void noise_playback_manager_pause_playback (NoisePlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
NoisePlaybackManager* noise_playback_manager_new (void);
NoisePlaybackManager* noise_playback_manager_construct (GType object_type);
gint noise_playback_manager_get_current_index (NoisePlaybackManager* self);
gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * noise_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
NoiseHistoryPlaylist* noise_history_playlist_new (void);
NoiseHistoryPlaylist* noise_history_playlist_construct (GType object_type);
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static void noise_playback_manager_finalize (GObject * obj);
static void _vala_noise_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
noise_playback_manager_get_instance_private (NoisePlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlaybackManager_private_offset);
}

void
noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                     NoisePlayback* playback)
{
	GeeTreeSet* _tmp0_;
#line 116 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/PlaybackManager.vala"
	g_return_if_fail (playback != NULL);
#line 117 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbacks;
#line 117 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
#line 250 "PlaybackManager.c"
}

void
noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	NoiseStaticPlaylist* _tmp10_;
#line 120 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/PlaybackManager.vala"
	g_return_if_fail (to_queue != NULL);
#line 121 "../src/PlaybackManager.vala"
	_tmp0_ = gee_collection_get_size (to_queue);
#line 121 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 121 "../src/PlaybackManager.vala"
	if (_tmp1_ < 1) {
#line 122 "../src/PlaybackManager.vala"
		return;
#line 272 "PlaybackManager.c"
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
#line 125 "../src/PlaybackManager.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
#line 125 "../src/PlaybackManager.vala"
		_q_it = _tmp2_;
#line 125 "../src/PlaybackManager.vala"
		while (TRUE) {
#line 283 "PlaybackManager.c"
			GeeIterator* _tmp3_;
			NoiseMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			NoiseMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			NoiseMedia* _tmp9_;
#line 125 "../src/PlaybackManager.vala"
			_tmp3_ = _q_it;
#line 125 "../src/PlaybackManager.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 125 "../src/PlaybackManager.vala"
				break;
#line 298 "PlaybackManager.c"
			}
#line 125 "../src/PlaybackManager.vala"
			_tmp4_ = _q_it;
#line 125 "../src/PlaybackManager.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 125 "../src/PlaybackManager.vala"
			q = (NoiseMedia*) _tmp5_;
#line 126 "../src/PlaybackManager.vala"
			_tmp6_ = q;
#line 126 "../src/PlaybackManager.vala"
			_tmp7_ = noise_media_get_title (_tmp6_);
#line 126 "../src/PlaybackManager.vala"
			_tmp8_ = _tmp7_;
#line 126 "../src/PlaybackManager.vala"
			g_debug ("PlaybackManager.vala:126: QUEUED: %s", _tmp8_);
#line 127 "../src/PlaybackManager.vala"
			_tmp9_ = q;
#line 127 "../src/PlaybackManager.vala"
			noise_playback_manager_add_to_current (self, _tmp9_);
#line 125 "../src/PlaybackManager.vala"
			_g_object_unref0 (q);
#line 320 "PlaybackManager.c"
		}
#line 125 "../src/PlaybackManager.vala"
		_g_object_unref0 (_q_it);
#line 324 "PlaybackManager.c"
	}
#line 130 "../src/PlaybackManager.vala"
	_tmp10_ = self->queue_playlist;
#line 130 "../src/PlaybackManager.vala"
	noise_playlist_add_medias ((NoisePlaylist*) _tmp10_, to_queue);
#line 131 "../src/PlaybackManager.vala"
	noise_playback_manager_reshuffle (self);
#line 332 "PlaybackManager.c"
}

void
noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	NoiseStaticPlaylist* _tmp0_;
#line 134 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/PlaybackManager.vala"
	g_return_if_fail (to_unqueue != NULL);
#line 135 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 135 "../src/PlaybackManager.vala"
	noise_playlist_remove_medias ((NoisePlaylist*) _tmp0_, to_unqueue);
#line 348 "PlaybackManager.c"
}

static NoiseMedia*
noise_playback_manager_poll_queue (NoisePlaybackManager* self)
{
	NoiseMedia* result = NULL;
	NoiseMedia* m = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gpointer _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gpointer _tmp7_;
	NoiseMedia* _tmp8_;
	GeeLinkedList* unqueued = NULL;
	GeeLinkedList* _tmp9_;
	NoiseStaticPlaylist* _tmp10_;
#line 138 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 139 "../src/PlaybackManager.vala"
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
#line 139 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 139 "../src/PlaybackManager.vala"
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
#line 139 "../src/PlaybackManager.vala"
	m = (NoiseMedia*) _tmp3_;
#line 140 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 140 "../src/PlaybackManager.vala"
	_tmp5_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp4_);
#line 140 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 140 "../src/PlaybackManager.vala"
	_tmp7_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp6_, 0);
#line 140 "../src/PlaybackManager.vala"
	_tmp8_ = (NoiseMedia*) _tmp7_;
#line 140 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp8_);
#line 141 "../src/PlaybackManager.vala"
	_tmp9_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 141 "../src/PlaybackManager.vala"
	unqueued = _tmp9_;
#line 142 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) unqueued, m);
#line 143 "../src/PlaybackManager.vala"
	_tmp10_ = self->queue_playlist;
#line 143 "../src/PlaybackManager.vala"
	g_signal_emit_by_name ((NoisePlaylist*) _tmp10_, "media-removed", (GeeCollection*) unqueued);
#line 144 "../src/PlaybackManager.vala"
	result = m;
#line 144 "../src/PlaybackManager.vala"
	_g_object_unref0 (unqueued);
#line 144 "../src/PlaybackManager.vala"
	return result;
#line 408 "PlaybackManager.c"
}

void
noise_playback_manager_clear_queue (NoisePlaybackManager* self)
{
	NoiseStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
#line 147 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 148 "../src/PlaybackManager.vala"
	noise_playlist_clear ((NoisePlaylist*) _tmp0_);
#line 149 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 149 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
#line 150 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_index (self, 0);
#line 152 "../src/PlaybackManager.vala"
	noise_playback_manager_reshuffle (self);
#line 430 "PlaybackManager.c"
}

NoiseMedia*
noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                 gint index_in_current)
{
	NoiseMedia* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 155 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 156 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 156 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 156 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 156 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 156 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 156 "../src/PlaybackManager.vala"
	if (_tmp4_) {
#line 459 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
#line 157 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current;
#line 157 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) index_in_current));
#line 157 "../src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp6_;
#line 157 "../src/PlaybackManager.vala"
		return result;
#line 470 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp7_;
		gpointer _tmp8_;
#line 159 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_current_shuffled;
#line 159 "../src/PlaybackManager.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) index_in_current));
#line 159 "../src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp8_;
#line 159 "../src/PlaybackManager.vala"
		return result;
#line 482 "PlaybackManager.c"
	}
}

GeeCollection*
noise_playback_manager_get_current_media_list (NoisePlaybackManager* self)
{
	GeeCollection* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 163 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 164 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 164 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 164 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 164 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 164 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 164 "../src/PlaybackManager.vala"
	if (_tmp4_) {
#line 511 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 165 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_shuffled;
#line 165 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
#line 165 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 165 "../src/PlaybackManager.vala"
		result = _tmp7_;
#line 165 "../src/PlaybackManager.vala"
		return result;
#line 525 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
#line 167 "../src/PlaybackManager.vala"
		_tmp8_ = self->priv->_current;
#line 167 "../src/PlaybackManager.vala"
		_tmp9_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp8_);
#line 167 "../src/PlaybackManager.vala"
		_tmp10_ = _tmp9_;
#line 167 "../src/PlaybackManager.vala"
		result = _tmp10_;
#line 167 "../src/PlaybackManager.vala"
		return result;
#line 540 "PlaybackManager.c"
	}
}

static void
noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                       NoiseMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 171 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 172 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 172 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 172 "../src/PlaybackManager.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 172 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 172 "../src/PlaybackManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
#line 566 "PlaybackManager.c"
}

void
noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                        NoiseSettingsRepeat mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsRepeat _tmp2_;
	NoiseSettingsRepeat _tmp3_;
#line 175 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 176 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 177 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 177 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_repeat_mode (_tmp1_);
#line 177 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 177 "../src/PlaybackManager.vala"
	if (_tmp3_ != mode) {
#line 592 "PlaybackManager.c"
		NoiseSettingsMain* _tmp4_;
#line 178 "../src/PlaybackManager.vala"
		_tmp4_ = main_settings;
#line 178 "../src/PlaybackManager.vala"
		noise_settings_main_set_repeat_mode (_tmp4_, mode);
#line 598 "PlaybackManager.c"
	}
#line 175 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 602 "PlaybackManager.c"
}

void
noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                         NoiseSettingsShuffle mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
#line 182 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 183 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 184 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 184 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 184 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 184 "../src/PlaybackManager.vala"
	if (_tmp3_ != mode) {
#line 628 "PlaybackManager.c"
		NoiseSettingsMain* _tmp4_;
#line 185 "../src/PlaybackManager.vala"
		_tmp4_ = main_settings;
#line 185 "../src/PlaybackManager.vala"
		noise_settings_main_set_shuffle_mode (_tmp4_, mode);
#line 186 "../src/PlaybackManager.vala"
		noise_playback_manager_reshuffle (self);
#line 636 "PlaybackManager.c"
	}
#line 182 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 640 "PlaybackManager.c"
}

/**
    * Regenerate the shuffled queue if needed
    */
static void
noise_playback_manager_reshuffle (NoisePlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseSettingsShuffle _tmp4_;
#line 193 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:194: Reshuffling");
#line 195 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 195 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 196 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled_index = 0;
#line 198 "../src/PlaybackManager.vala"
	_tmp1_ = noise_settings_main_get_default ();
#line 198 "../src/PlaybackManager.vala"
	main_settings = _tmp1_;
#line 199 "../src/PlaybackManager.vala"
	_tmp2_ = main_settings;
#line 199 "../src/PlaybackManager.vala"
	_tmp3_ = noise_settings_main_get_shuffle_mode (_tmp2_);
#line 199 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 199 "../src/PlaybackManager.vala"
	if (_tmp4_ == NOISE_SETTINGS_SHUFFLE_OFF) {
#line 677 "PlaybackManager.c"
		NoiseMedia* _tmp5_;
#line 200 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_media;
#line 200 "../src/PlaybackManager.vala"
		if (_tmp5_ != NULL) {
#line 683 "PlaybackManager.c"
			{
				gint i = 0;
#line 202 "../src/PlaybackManager.vala"
				i = 0;
#line 688 "PlaybackManager.c"
				{
					gboolean _tmp6_ = FALSE;
#line 202 "../src/PlaybackManager.vala"
					_tmp6_ = TRUE;
#line 202 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 695 "PlaybackManager.c"
						GeeHashMap* _tmp7_;
						gint _tmp8_;
						gint _tmp9_;
						GeeHashMap* _tmp10_;
						gpointer _tmp11_;
						NoiseMedia* _tmp12_;
						NoiseMedia* _tmp13_;
						gboolean _tmp14_;
#line 202 "../src/PlaybackManager.vala"
						if (!_tmp6_) {
#line 202 "../src/PlaybackManager.vala"
							i = i + 1;
#line 708 "PlaybackManager.c"
						}
#line 202 "../src/PlaybackManager.vala"
						_tmp6_ = FALSE;
#line 202 "../src/PlaybackManager.vala"
						_tmp7_ = self->priv->_current;
#line 202 "../src/PlaybackManager.vala"
						_tmp8_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp7_);
#line 202 "../src/PlaybackManager.vala"
						_tmp9_ = _tmp8_;
#line 202 "../src/PlaybackManager.vala"
						if (!(i < _tmp9_)) {
#line 202 "../src/PlaybackManager.vala"
							break;
#line 722 "PlaybackManager.c"
						}
#line 203 "../src/PlaybackManager.vala"
						_tmp10_ = self->priv->_current;
#line 203 "../src/PlaybackManager.vala"
						_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) i));
#line 203 "../src/PlaybackManager.vala"
						_tmp12_ = (NoiseMedia*) _tmp11_;
#line 203 "../src/PlaybackManager.vala"
						_tmp13_ = self->priv->_current_media;
#line 203 "../src/PlaybackManager.vala"
						_tmp14_ = _tmp12_ == _tmp13_;
#line 203 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp12_);
#line 203 "../src/PlaybackManager.vala"
						if (_tmp14_) {
#line 204 "../src/PlaybackManager.vala"
							self->priv->_current_index = i;
#line 205 "../src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 205 "../src/PlaybackManager.vala"
							return;
#line 744 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
#line 209 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 752 "PlaybackManager.c"
		}
	} else {
		NoiseSettingsMain* _tmp15_;
		NoiseSettingsShuffle _tmp16_;
		NoiseSettingsShuffle _tmp17_;
#line 211 "../src/PlaybackManager.vala"
		_tmp15_ = main_settings;
#line 211 "../src/PlaybackManager.vala"
		_tmp16_ = noise_settings_main_get_shuffle_mode (_tmp15_);
#line 211 "../src/PlaybackManager.vala"
		_tmp17_ = _tmp16_;
#line 211 "../src/PlaybackManager.vala"
		if (_tmp17_ == NOISE_SETTINGS_SHUFFLE_ALL) {
#line 766 "PlaybackManager.c"
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp18_;
			gboolean current_media_found = FALSE;
			gboolean _tmp32_ = FALSE;
			NoiseMedia* _tmp33_;
#line 213 "../src/PlaybackManager.vala"
			_tmp18_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 213 "../src/PlaybackManager.vala"
			temp = _tmp18_;
#line 214 "../src/PlaybackManager.vala"
			current_media_found = FALSE;
#line 778 "PlaybackManager.c"
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp19_;
				GeeCollection* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				GeeIterator* _tmp23_;
				GeeIterator* _tmp24_;
#line 215 "../src/PlaybackManager.vala"
				_tmp19_ = self->priv->_current;
#line 215 "../src/PlaybackManager.vala"
				_tmp20_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp19_);
#line 215 "../src/PlaybackManager.vala"
				_tmp21_ = _tmp20_;
#line 215 "../src/PlaybackManager.vala"
				_tmp22_ = _tmp21_;
#line 215 "../src/PlaybackManager.vala"
				_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 215 "../src/PlaybackManager.vala"
				_tmp24_ = _tmp23_;
#line 215 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp22_);
#line 215 "../src/PlaybackManager.vala"
				_m_it = _tmp24_;
#line 215 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 805 "PlaybackManager.c"
					GeeIterator* _tmp25_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp26_;
					gpointer _tmp27_;
					NoiseMedia* _tmp28_;
					NoiseMedia* _tmp29_;
#line 215 "../src/PlaybackManager.vala"
					_tmp25_ = _m_it;
#line 215 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp25_)) {
#line 215 "../src/PlaybackManager.vala"
						break;
#line 818 "PlaybackManager.c"
					}
#line 215 "../src/PlaybackManager.vala"
					_tmp26_ = _m_it;
#line 215 "../src/PlaybackManager.vala"
					_tmp27_ = gee_iterator_get (_tmp26_);
#line 215 "../src/PlaybackManager.vala"
					m = (NoiseMedia*) _tmp27_;
#line 216 "../src/PlaybackManager.vala"
					_tmp28_ = self->priv->_current_media;
#line 216 "../src/PlaybackManager.vala"
					_tmp29_ = m;
#line 216 "../src/PlaybackManager.vala"
					if (_tmp28_ != _tmp29_) {
#line 832 "PlaybackManager.c"
						GeeLinkedList* _tmp30_;
						NoiseMedia* _tmp31_;
#line 217 "../src/PlaybackManager.vala"
						_tmp30_ = temp;
#line 217 "../src/PlaybackManager.vala"
						_tmp31_ = m;
#line 217 "../src/PlaybackManager.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 841 "PlaybackManager.c"
					} else {
#line 219 "../src/PlaybackManager.vala"
						current_media_found = TRUE;
#line 845 "PlaybackManager.c"
					}
#line 215 "../src/PlaybackManager.vala"
					_g_object_unref0 (m);
#line 849 "PlaybackManager.c"
				}
#line 215 "../src/PlaybackManager.vala"
				_g_object_unref0 (_m_it);
#line 853 "PlaybackManager.c"
			}
#line 228 "../src/PlaybackManager.vala"
			_tmp33_ = self->priv->_current_media;
#line 228 "../src/PlaybackManager.vala"
			if (_tmp33_ != NULL) {
#line 228 "../src/PlaybackManager.vala"
				_tmp32_ = current_media_found;
#line 861 "PlaybackManager.c"
			} else {
#line 228 "../src/PlaybackManager.vala"
				_tmp32_ = FALSE;
#line 865 "PlaybackManager.c"
			}
#line 228 "../src/PlaybackManager.vala"
			if (_tmp32_) {
#line 869 "PlaybackManager.c"
				GeeHashMap* _tmp34_;
				NoiseMedia* _tmp35_;
#line 229 "../src/PlaybackManager.vala"
				_tmp34_ = self->priv->_current_shuffled;
#line 229 "../src/PlaybackManager.vala"
				_tmp35_ = self->priv->_current_media;
#line 229 "../src/PlaybackManager.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp34_, (gpointer) ((gintptr) 0), _tmp35_);
#line 878 "PlaybackManager.c"
			} else {
				gboolean _tmp36_ = FALSE;
				NoiseMedia* _tmp37_;
#line 230 "../src/PlaybackManager.vala"
				_tmp37_ = self->priv->_current_media;
#line 230 "../src/PlaybackManager.vala"
				if (_tmp37_ != NULL) {
#line 886 "PlaybackManager.c"
					GeeHashMap* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
#line 230 "../src/PlaybackManager.vala"
					_tmp38_ = self->priv->_current;
#line 230 "../src/PlaybackManager.vala"
					_tmp39_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp38_);
#line 230 "../src/PlaybackManager.vala"
					_tmp40_ = _tmp39_;
#line 230 "../src/PlaybackManager.vala"
					_tmp36_ = _tmp40_ != 0;
#line 898 "PlaybackManager.c"
				} else {
#line 230 "../src/PlaybackManager.vala"
					_tmp36_ = FALSE;
#line 902 "PlaybackManager.c"
				}
#line 230 "../src/PlaybackManager.vala"
				if (_tmp36_) {
#line 906 "PlaybackManager.c"
					GeeHashMap* _tmp41_;
					GeeHashMap* _tmp42_;
					gpointer _tmp43_;
					NoiseMedia* _tmp44_;
#line 233 "../src/PlaybackManager.vala"
					_tmp41_ = self->priv->_current_shuffled;
#line 233 "../src/PlaybackManager.vala"
					_tmp42_ = self->priv->_current;
#line 233 "../src/PlaybackManager.vala"
					_tmp43_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp42_, (gpointer) ((gintptr) 0));
#line 233 "../src/PlaybackManager.vala"
					_tmp44_ = (NoiseMedia*) _tmp43_;
#line 233 "../src/PlaybackManager.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) 0), _tmp44_);
#line 233 "../src/PlaybackManager.vala"
					_g_object_unref0 (_tmp44_);
#line 923 "PlaybackManager.c"
				}
			}
			{
				gint _tmp45_ = 0;
				NoiseMedia* _tmp46_;
				gint i = 0;
#line 236 "../src/PlaybackManager.vala"
				_tmp46_ = self->priv->_current_media;
#line 236 "../src/PlaybackManager.vala"
				if (_tmp46_ == NULL) {
#line 236 "../src/PlaybackManager.vala"
					_tmp45_ = 0;
#line 936 "PlaybackManager.c"
				} else {
#line 236 "../src/PlaybackManager.vala"
					_tmp45_ = 1;
#line 940 "PlaybackManager.c"
				}
#line 236 "../src/PlaybackManager.vala"
				i = _tmp45_;
#line 944 "PlaybackManager.c"
				{
					gboolean _tmp47_ = FALSE;
#line 236 "../src/PlaybackManager.vala"
					_tmp47_ = TRUE;
#line 236 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 951 "PlaybackManager.c"
						GeeHashMap* _tmp49_;
						gint _tmp50_;
						gint _tmp51_;
						gint n_media = 0;
						GeeLinkedList* _tmp52_;
						gint _tmp53_;
						gint _tmp54_;
						gint random = 0;
						GeeHashMap* _tmp55_;
						GeeLinkedList* _tmp56_;
						gpointer _tmp57_;
						NoiseMedia* _tmp58_;
						GeeLinkedList* _tmp59_;
						GeeLinkedList* _tmp60_;
						gpointer _tmp61_;
						NoiseMedia* _tmp62_;
#line 236 "../src/PlaybackManager.vala"
						if (!_tmp47_) {
#line 970 "PlaybackManager.c"
							gint _tmp48_;
#line 236 "../src/PlaybackManager.vala"
							_tmp48_ = i;
#line 236 "../src/PlaybackManager.vala"
							i = _tmp48_ + 1;
#line 976 "PlaybackManager.c"
						}
#line 236 "../src/PlaybackManager.vala"
						_tmp47_ = FALSE;
#line 236 "../src/PlaybackManager.vala"
						_tmp49_ = self->priv->_current;
#line 236 "../src/PlaybackManager.vala"
						_tmp50_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp49_);
#line 236 "../src/PlaybackManager.vala"
						_tmp51_ = _tmp50_;
#line 236 "../src/PlaybackManager.vala"
						if (!(i < _tmp51_)) {
#line 236 "../src/PlaybackManager.vala"
							break;
#line 990 "PlaybackManager.c"
						}
#line 237 "../src/PlaybackManager.vala"
						_tmp52_ = temp;
#line 237 "../src/PlaybackManager.vala"
						_tmp53_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp52_);
#line 237 "../src/PlaybackManager.vala"
						_tmp54_ = _tmp53_;
#line 237 "../src/PlaybackManager.vala"
						n_media = _tmp54_;
#line 238 "../src/PlaybackManager.vala"
						if (n_media == 0) {
#line 239 "../src/PlaybackManager.vala"
							break;
#line 1004 "PlaybackManager.c"
						}
#line 242 "../src/PlaybackManager.vala"
						random = (gint) g_random_int_range ((gint32) 0, (gint32) n_media);
#line 244 "../src/PlaybackManager.vala"
						_tmp55_ = self->priv->_current_shuffled;
#line 244 "../src/PlaybackManager.vala"
						_tmp56_ = temp;
#line 244 "../src/PlaybackManager.vala"
						_tmp57_ = gee_abstract_list_get ((GeeAbstractList*) _tmp56_, random);
#line 244 "../src/PlaybackManager.vala"
						_tmp58_ = (NoiseMedia*) _tmp57_;
#line 244 "../src/PlaybackManager.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, (gpointer) ((gintptr) i), _tmp58_);
#line 244 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp58_);
#line 245 "../src/PlaybackManager.vala"
						_tmp59_ = temp;
#line 245 "../src/PlaybackManager.vala"
						_tmp60_ = temp;
#line 245 "../src/PlaybackManager.vala"
						_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp60_, random);
#line 245 "../src/PlaybackManager.vala"
						_tmp62_ = (NoiseMedia*) _tmp61_;
#line 245 "../src/PlaybackManager.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp59_, _tmp62_);
#line 245 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp62_);
#line 1032 "PlaybackManager.c"
					}
				}
			}
#line 211 "../src/PlaybackManager.vala"
			_g_object_unref0 (temp);
#line 1038 "PlaybackManager.c"
		}
	}
#line 193 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 1043 "PlaybackManager.c"
}

NoiseMedia*
noise_playback_manager_get_next (NoisePlaybackManager* self,
                                 gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseStaticPlaylist* _tmp159_;
	GeeArrayList* _tmp160_;
	GeeArrayList* _tmp161_;
	NoiseMedia* _tmp162_;
#line 250 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 251 "../src/PlaybackManager.vala"
	rv = NULL;
#line 253 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 253 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 254 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 254 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 254 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 254 "../src/PlaybackManager.vala"
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 1077 "PlaybackManager.c"
		GeeHashMap* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GeeHashMap* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		NoiseMedia* _tmp17_;
#line 255 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 255 "../src/PlaybackManager.vala"
		_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
#line 255 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 255 "../src/PlaybackManager.vala"
		g_debug ("PlaybackManager.vala:255: Shuffled size: %d", _tmp6_);
#line 256 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_current_shuffled;
#line 256 "../src/PlaybackManager.vala"
		_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
#line 256 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 256 "../src/PlaybackManager.vala"
		if (_tmp9_) {
#line 1101 "PlaybackManager.c"
			GeeHashMap* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 257 "../src/PlaybackManager.vala"
			_tmp10_ = self->priv->_current;
#line 257 "../src/PlaybackManager.vala"
			_tmp11_ = gee_map_get_is_empty ((GeeMap*) _tmp10_);
#line 257 "../src/PlaybackManager.vala"
			_tmp12_ = _tmp11_;
#line 257 "../src/PlaybackManager.vala"
			if (_tmp12_) {
#line 1113 "PlaybackManager.c"
				NoiseLibrary* _tmp13_;
				NoiseLibrary* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
#line 258 "../src/PlaybackManager.vala"
				_tmp13_ = noise_playback_manager_get_library (self);
#line 258 "../src/PlaybackManager.vala"
				_tmp14_ = _tmp13_;
#line 258 "../src/PlaybackManager.vala"
				_tmp15_ = noise_library_get_medias (_tmp14_);
#line 258 "../src/PlaybackManager.vala"
				_tmp16_ = _tmp15_;
#line 258 "../src/PlaybackManager.vala"
				noise_playback_manager_queue_media (self, _tmp16_);
#line 258 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp16_);
#line 1130 "PlaybackManager.c"
			}
#line 261 "../src/PlaybackManager.vala"
			noise_playback_manager_reshuffle (self);
#line 1134 "PlaybackManager.c"
		}
#line 264 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 266 "../src/PlaybackManager.vala"
		_tmp17_ = self->priv->_current_media;
#line 266 "../src/PlaybackManager.vala"
		if (_tmp17_ == NULL) {
#line 1142 "PlaybackManager.c"
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
#line 267 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = 0;
#line 268 "../src/PlaybackManager.vala"
			_tmp18_ = self->priv->_current_shuffled;
#line 268 "../src/PlaybackManager.vala"
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) 0));
#line 268 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 268 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp19_;
#line 1155 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp20_;
			NoiseSettingsRepeat _tmp21_;
			NoiseSettingsRepeat _tmp22_;
#line 269 "../src/PlaybackManager.vala"
			_tmp20_ = main_settings;
#line 269 "../src/PlaybackManager.vala"
			_tmp21_ = noise_settings_main_get_repeat_mode (_tmp20_);
#line 269 "../src/PlaybackManager.vala"
			_tmp22_ = _tmp21_;
#line 269 "../src/PlaybackManager.vala"
			if (_tmp22_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1168 "PlaybackManager.c"
				GeeHashMap* _tmp23_;
				gpointer _tmp24_;
#line 270 "../src/PlaybackManager.vala"
				_tmp23_ = self->priv->_current_shuffled;
#line 270 "../src/PlaybackManager.vala"
				_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 270 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 270 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp24_;
#line 1179 "PlaybackManager.c"
			} else {
				GeeHashMap* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
#line 271 "../src/PlaybackManager.vala"
				_tmp25_ = self->priv->_current_shuffled;
#line 271 "../src/PlaybackManager.vala"
				_tmp26_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp25_);
#line 271 "../src/PlaybackManager.vala"
				_tmp27_ = _tmp26_;
#line 271 "../src/PlaybackManager.vala"
				if (self->priv->_current_shuffled_index == (_tmp27_ - 1)) {
#line 1192 "PlaybackManager.c"
					NoiseSettingsMain* _tmp28_;
					NoiseSettingsRepeat _tmp29_;
					NoiseSettingsRepeat _tmp30_;
					GeeHashMap* _tmp31_;
					gpointer _tmp32_;
#line 272 "../src/PlaybackManager.vala"
					_tmp28_ = main_settings;
#line 272 "../src/PlaybackManager.vala"
					_tmp29_ = noise_settings_main_get_repeat_mode (_tmp28_);
#line 272 "../src/PlaybackManager.vala"
					_tmp30_ = _tmp29_;
#line 272 "../src/PlaybackManager.vala"
					if (_tmp30_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 273 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = 0;
#line 1208 "PlaybackManager.c"
					} else {
#line 276 "../src/PlaybackManager.vala"
						if (play) {
#line 277 "../src/PlaybackManager.vala"
							noise_playback_manager_stop_playback (self);
#line 1214 "PlaybackManager.c"
						}
#line 280 "../src/PlaybackManager.vala"
						result = NULL;
#line 280 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 280 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 280 "../src/PlaybackManager.vala"
						return result;
#line 1224 "PlaybackManager.c"
					}
#line 283 "../src/PlaybackManager.vala"
					_tmp31_ = self->priv->_current_shuffled;
#line 283 "../src/PlaybackManager.vala"
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) 0));
#line 283 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 283 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp32_;
#line 1234 "PlaybackManager.c"
				} else {
					gboolean _tmp33_ = FALSE;
#line 284 "../src/PlaybackManager.vala"
					if (self->priv->_current_shuffled_index >= 0) {
#line 1239 "PlaybackManager.c"
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
#line 284 "../src/PlaybackManager.vala"
						_tmp34_ = self->priv->_current_shuffled;
#line 284 "../src/PlaybackManager.vala"
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
#line 284 "../src/PlaybackManager.vala"
						_tmp36_ = _tmp35_;
#line 284 "../src/PlaybackManager.vala"
						_tmp33_ = self->priv->_current_shuffled_index < (_tmp36_ - 1);
#line 1251 "PlaybackManager.c"
					} else {
#line 284 "../src/PlaybackManager.vala"
						_tmp33_ = FALSE;
#line 1255 "PlaybackManager.c"
					}
#line 284 "../src/PlaybackManager.vala"
					if (_tmp33_) {
#line 1259 "PlaybackManager.c"
						NoiseMedia* next_current = NULL;
						GeeHashMap* _tmp37_;
						gpointer _tmp38_;
						NoiseMedia* now_current = NULL;
						GeeHashMap* _tmp39_;
						gpointer _tmp40_;
						gboolean _tmp41_ = FALSE;
						NoiseSettingsMain* _tmp42_;
						NoiseSettingsRepeat _tmp43_;
						NoiseSettingsRepeat _tmp44_;
						GeeHashMap* _tmp82_;
						gpointer _tmp83_;
#line 286 "../src/PlaybackManager.vala"
						_tmp37_ = self->priv->_current_shuffled;
#line 286 "../src/PlaybackManager.vala"
						_tmp38_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp37_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
#line 286 "../src/PlaybackManager.vala"
						next_current = (NoiseMedia*) _tmp38_;
#line 287 "../src/PlaybackManager.vala"
						_tmp39_ = self->priv->_current_shuffled;
#line 287 "../src/PlaybackManager.vala"
						_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 287 "../src/PlaybackManager.vala"
						now_current = (NoiseMedia*) _tmp40_;
#line 289 "../src/PlaybackManager.vala"
						_tmp42_ = main_settings;
#line 289 "../src/PlaybackManager.vala"
						_tmp43_ = noise_settings_main_get_repeat_mode (_tmp42_);
#line 289 "../src/PlaybackManager.vala"
						_tmp44_ = _tmp43_;
#line 289 "../src/PlaybackManager.vala"
						if (_tmp44_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1292 "PlaybackManager.c"
							NoiseMedia* _tmp45_;
							const gchar* _tmp46_;
							const gchar* _tmp47_;
							NoiseMedia* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
#line 289 "../src/PlaybackManager.vala"
							_tmp45_ = next_current;
#line 289 "../src/PlaybackManager.vala"
							_tmp46_ = noise_media_get_artist (_tmp45_);
#line 289 "../src/PlaybackManager.vala"
							_tmp47_ = _tmp46_;
#line 289 "../src/PlaybackManager.vala"
							_tmp48_ = now_current;
#line 289 "../src/PlaybackManager.vala"
							_tmp49_ = noise_media_get_artist (_tmp48_);
#line 289 "../src/PlaybackManager.vala"
							_tmp50_ = _tmp49_;
#line 289 "../src/PlaybackManager.vala"
							_tmp41_ = g_strcmp0 (_tmp47_, _tmp50_) != 0;
#line 1313 "PlaybackManager.c"
						} else {
#line 289 "../src/PlaybackManager.vala"
							_tmp41_ = FALSE;
#line 1317 "PlaybackManager.c"
						}
#line 289 "../src/PlaybackManager.vala"
						if (_tmp41_) {
#line 290 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 1323 "PlaybackManager.c"
								GeeHashMap* _tmp51_;
								gpointer _tmp52_;
								NoiseMedia* _tmp53_;
								const gchar* _tmp54_;
								const gchar* _tmp55_;
								NoiseMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
								gint _tmp60_;
#line 290 "../src/PlaybackManager.vala"
								_tmp51_ = self->priv->_current_shuffled;
#line 290 "../src/PlaybackManager.vala"
								_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 290 "../src/PlaybackManager.vala"
								_tmp53_ = (NoiseMedia*) _tmp52_;
#line 290 "../src/PlaybackManager.vala"
								_tmp54_ = noise_media_get_artist (_tmp53_);
#line 290 "../src/PlaybackManager.vala"
								_tmp55_ = _tmp54_;
#line 290 "../src/PlaybackManager.vala"
								_tmp56_ = self->priv->_current_media;
#line 290 "../src/PlaybackManager.vala"
								_tmp57_ = noise_media_get_artist (_tmp56_);
#line 290 "../src/PlaybackManager.vala"
								_tmp58_ = _tmp57_;
#line 290 "../src/PlaybackManager.vala"
								_tmp59_ = !(g_strcmp0 (_tmp55_, _tmp58_) == 0);
#line 290 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp53_);
#line 290 "../src/PlaybackManager.vala"
								if (_tmp59_) {
#line 290 "../src/PlaybackManager.vala"
									break;
#line 1358 "PlaybackManager.c"
								}
#line 291 "../src/PlaybackManager.vala"
								_tmp60_ = self->priv->_current_shuffled_index;
#line 291 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp60_ - 1;
#line 1364 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp61_ = FALSE;
							NoiseSettingsMain* _tmp62_;
							NoiseSettingsRepeat _tmp63_;
							NoiseSettingsRepeat _tmp64_;
#line 293 "../src/PlaybackManager.vala"
							_tmp62_ = main_settings;
#line 293 "../src/PlaybackManager.vala"
							_tmp63_ = noise_settings_main_get_repeat_mode (_tmp62_);
#line 293 "../src/PlaybackManager.vala"
							_tmp64_ = _tmp63_;
#line 293 "../src/PlaybackManager.vala"
							if (_tmp64_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1379 "PlaybackManager.c"
								NoiseMedia* _tmp65_;
								const gchar* _tmp66_;
								const gchar* _tmp67_;
								NoiseMedia* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
#line 293 "../src/PlaybackManager.vala"
								_tmp65_ = next_current;
#line 293 "../src/PlaybackManager.vala"
								_tmp66_ = noise_media_get_album (_tmp65_);
#line 293 "../src/PlaybackManager.vala"
								_tmp67_ = _tmp66_;
#line 293 "../src/PlaybackManager.vala"
								_tmp68_ = now_current;
#line 293 "../src/PlaybackManager.vala"
								_tmp69_ = noise_media_get_album (_tmp68_);
#line 293 "../src/PlaybackManager.vala"
								_tmp70_ = _tmp69_;
#line 293 "../src/PlaybackManager.vala"
								_tmp61_ = g_strcmp0 (_tmp67_, _tmp70_) != 0;
#line 1400 "PlaybackManager.c"
							} else {
#line 293 "../src/PlaybackManager.vala"
								_tmp61_ = FALSE;
#line 1404 "PlaybackManager.c"
							}
#line 293 "../src/PlaybackManager.vala"
							if (_tmp61_) {
#line 294 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1410 "PlaybackManager.c"
									GeeHashMap* _tmp71_;
									gpointer _tmp72_;
									NoiseMedia* _tmp73_;
									const gchar* _tmp74_;
									const gchar* _tmp75_;
									NoiseMedia* _tmp76_;
									const gchar* _tmp77_;
									const gchar* _tmp78_;
									gboolean _tmp79_;
									gint _tmp80_;
#line 294 "../src/PlaybackManager.vala"
									_tmp71_ = self->priv->_current_shuffled;
#line 294 "../src/PlaybackManager.vala"
									_tmp72_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp71_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 294 "../src/PlaybackManager.vala"
									_tmp73_ = (NoiseMedia*) _tmp72_;
#line 294 "../src/PlaybackManager.vala"
									_tmp74_ = noise_media_get_album (_tmp73_);
#line 294 "../src/PlaybackManager.vala"
									_tmp75_ = _tmp74_;
#line 294 "../src/PlaybackManager.vala"
									_tmp76_ = self->priv->_current_media;
#line 294 "../src/PlaybackManager.vala"
									_tmp77_ = noise_media_get_album (_tmp76_);
#line 294 "../src/PlaybackManager.vala"
									_tmp78_ = _tmp77_;
#line 294 "../src/PlaybackManager.vala"
									_tmp79_ = !(g_strcmp0 (_tmp75_, _tmp78_) == 0);
#line 294 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp73_);
#line 294 "../src/PlaybackManager.vala"
									if (_tmp79_) {
#line 294 "../src/PlaybackManager.vala"
										break;
#line 1445 "PlaybackManager.c"
									}
#line 295 "../src/PlaybackManager.vala"
									_tmp80_ = self->priv->_current_shuffled_index;
#line 295 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp80_ - 1;
#line 1451 "PlaybackManager.c"
								}
							} else {
								gint _tmp81_;
#line 298 "../src/PlaybackManager.vala"
								_tmp81_ = self->priv->_current_shuffled_index;
#line 298 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp81_ + 1;
#line 1459 "PlaybackManager.c"
							}
						}
#line 301 "../src/PlaybackManager.vala"
						_tmp82_ = self->priv->_current_shuffled;
#line 301 "../src/PlaybackManager.vala"
						_tmp83_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp82_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 301 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 301 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp83_;
#line 284 "../src/PlaybackManager.vala"
						_g_object_unref0 (now_current);
#line 284 "../src/PlaybackManager.vala"
						_g_object_unref0 (next_current);
#line 1474 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp84_;
						gpointer _tmp85_;
#line 303 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = 0;
#line 304 "../src/PlaybackManager.vala"
						noise_playback_manager_set_shuffle_mode (self, NOISE_SETTINGS_SHUFFLE_ALL);
#line 305 "../src/PlaybackManager.vala"
						_tmp84_ = self->priv->_current_shuffled;
#line 305 "../src/PlaybackManager.vala"
						_tmp85_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp84_, (gpointer) ((gintptr) 0));
#line 305 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 305 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp85_;
#line 1490 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp86_;
#line 308 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 310 "../src/PlaybackManager.vala"
		_tmp86_ = self->priv->_current_media;
#line 310 "../src/PlaybackManager.vala"
		if (_tmp86_ == NULL) {
#line 1503 "PlaybackManager.c"
			GeeHashMap* _tmp87_;
			gpointer _tmp88_;
#line 311 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 312 "../src/PlaybackManager.vala"
			_tmp87_ = self->priv->_current;
#line 312 "../src/PlaybackManager.vala"
			_tmp88_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp87_, (gpointer) ((gintptr) 0));
#line 312 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 312 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp88_;
#line 1516 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp89_;
			NoiseSettingsRepeat _tmp90_;
			NoiseSettingsRepeat _tmp91_;
#line 313 "../src/PlaybackManager.vala"
			_tmp89_ = main_settings;
#line 313 "../src/PlaybackManager.vala"
			_tmp90_ = noise_settings_main_get_repeat_mode (_tmp89_);
#line 313 "../src/PlaybackManager.vala"
			_tmp91_ = _tmp90_;
#line 313 "../src/PlaybackManager.vala"
			if (_tmp91_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1529 "PlaybackManager.c"
				GeeHashMap* _tmp92_;
				gpointer _tmp93_;
#line 314 "../src/PlaybackManager.vala"
				_tmp92_ = self->priv->_current;
#line 314 "../src/PlaybackManager.vala"
				_tmp93_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp92_, (gpointer) ((gintptr) self->priv->_current_index));
#line 314 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 314 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp93_;
#line 1540 "PlaybackManager.c"
			} else {
				GeeHashMap* _tmp94_;
				gint _tmp95_;
				gint _tmp96_;
#line 315 "../src/PlaybackManager.vala"
				_tmp94_ = self->priv->_current;
#line 315 "../src/PlaybackManager.vala"
				_tmp95_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp94_);
#line 315 "../src/PlaybackManager.vala"
				_tmp96_ = _tmp95_;
#line 315 "../src/PlaybackManager.vala"
				if (self->priv->_current_index == (_tmp96_ - 1)) {
#line 1553 "PlaybackManager.c"
					NoiseSettingsMain* _tmp97_;
					NoiseSettingsRepeat _tmp98_;
					NoiseSettingsRepeat _tmp99_;
					GeeHashMap* _tmp100_;
					gpointer _tmp101_;
#line 316 "../src/PlaybackManager.vala"
					_tmp97_ = main_settings;
#line 316 "../src/PlaybackManager.vala"
					_tmp98_ = noise_settings_main_get_repeat_mode (_tmp97_);
#line 316 "../src/PlaybackManager.vala"
					_tmp99_ = _tmp98_;
#line 316 "../src/PlaybackManager.vala"
					if (_tmp99_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 317 "../src/PlaybackManager.vala"
						self->priv->_current_index = 0;
#line 1569 "PlaybackManager.c"
					} else {
#line 319 "../src/PlaybackManager.vala"
						if (play) {
#line 320 "../src/PlaybackManager.vala"
							noise_playback_manager_stop_playback (self);
#line 1575 "PlaybackManager.c"
						}
#line 322 "../src/PlaybackManager.vala"
						result = NULL;
#line 322 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 322 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 322 "../src/PlaybackManager.vala"
						return result;
#line 1585 "PlaybackManager.c"
					}
#line 325 "../src/PlaybackManager.vala"
					_tmp100_ = self->priv->_current;
#line 325 "../src/PlaybackManager.vala"
					_tmp101_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp100_, (gpointer) ((gintptr) 0));
#line 325 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 325 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp101_;
#line 1595 "PlaybackManager.c"
				} else {
					gboolean _tmp102_ = FALSE;
#line 326 "../src/PlaybackManager.vala"
					if (self->priv->_current_index >= 0) {
#line 1600 "PlaybackManager.c"
						GeeHashMap* _tmp103_;
						gint _tmp104_;
						gint _tmp105_;
#line 326 "../src/PlaybackManager.vala"
						_tmp103_ = self->priv->_current;
#line 326 "../src/PlaybackManager.vala"
						_tmp104_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp103_);
#line 326 "../src/PlaybackManager.vala"
						_tmp105_ = _tmp104_;
#line 326 "../src/PlaybackManager.vala"
						_tmp102_ = self->priv->_current_index < (_tmp105_ - 1);
#line 1612 "PlaybackManager.c"
					} else {
#line 326 "../src/PlaybackManager.vala"
						_tmp102_ = FALSE;
#line 1616 "PlaybackManager.c"
					}
#line 326 "../src/PlaybackManager.vala"
					if (_tmp102_) {
#line 1620 "PlaybackManager.c"
						NoiseMedia* next_current = NULL;
						GeeHashMap* _tmp106_;
						gpointer _tmp107_;
						NoiseMedia* now_current = NULL;
						GeeHashMap* _tmp108_;
						gpointer _tmp109_;
						gboolean _tmp110_ = FALSE;
						NoiseSettingsMain* _tmp111_;
						NoiseSettingsRepeat _tmp112_;
						NoiseSettingsRepeat _tmp113_;
						GeeHashMap* _tmp151_;
						gpointer _tmp152_;
#line 328 "../src/PlaybackManager.vala"
						_tmp106_ = self->priv->_current;
#line 328 "../src/PlaybackManager.vala"
						_tmp107_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp106_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
#line 328 "../src/PlaybackManager.vala"
						next_current = (NoiseMedia*) _tmp107_;
#line 329 "../src/PlaybackManager.vala"
						_tmp108_ = self->priv->_current;
#line 329 "../src/PlaybackManager.vala"
						_tmp109_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp108_, (gpointer) ((gintptr) self->priv->_current_index));
#line 329 "../src/PlaybackManager.vala"
						now_current = (NoiseMedia*) _tmp109_;
#line 331 "../src/PlaybackManager.vala"
						_tmp111_ = main_settings;
#line 331 "../src/PlaybackManager.vala"
						_tmp112_ = noise_settings_main_get_repeat_mode (_tmp111_);
#line 331 "../src/PlaybackManager.vala"
						_tmp113_ = _tmp112_;
#line 331 "../src/PlaybackManager.vala"
						if (_tmp113_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1653 "PlaybackManager.c"
							NoiseMedia* _tmp114_;
							const gchar* _tmp115_;
							const gchar* _tmp116_;
							NoiseMedia* _tmp117_;
							const gchar* _tmp118_;
							const gchar* _tmp119_;
#line 331 "../src/PlaybackManager.vala"
							_tmp114_ = next_current;
#line 331 "../src/PlaybackManager.vala"
							_tmp115_ = noise_media_get_artist (_tmp114_);
#line 331 "../src/PlaybackManager.vala"
							_tmp116_ = _tmp115_;
#line 331 "../src/PlaybackManager.vala"
							_tmp117_ = now_current;
#line 331 "../src/PlaybackManager.vala"
							_tmp118_ = noise_media_get_artist (_tmp117_);
#line 331 "../src/PlaybackManager.vala"
							_tmp119_ = _tmp118_;
#line 331 "../src/PlaybackManager.vala"
							_tmp110_ = g_strcmp0 (_tmp116_, _tmp119_) != 0;
#line 1674 "PlaybackManager.c"
						} else {
#line 331 "../src/PlaybackManager.vala"
							_tmp110_ = FALSE;
#line 1678 "PlaybackManager.c"
						}
#line 331 "../src/PlaybackManager.vala"
						if (_tmp110_) {
#line 332 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 1684 "PlaybackManager.c"
								GeeHashMap* _tmp120_;
								gpointer _tmp121_;
								NoiseMedia* _tmp122_;
								const gchar* _tmp123_;
								const gchar* _tmp124_;
								NoiseMedia* _tmp125_;
								const gchar* _tmp126_;
								const gchar* _tmp127_;
								gboolean _tmp128_;
								gint _tmp129_;
#line 332 "../src/PlaybackManager.vala"
								_tmp120_ = self->priv->_current;
#line 332 "../src/PlaybackManager.vala"
								_tmp121_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp120_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 332 "../src/PlaybackManager.vala"
								_tmp122_ = (NoiseMedia*) _tmp121_;
#line 332 "../src/PlaybackManager.vala"
								_tmp123_ = noise_media_get_artist (_tmp122_);
#line 332 "../src/PlaybackManager.vala"
								_tmp124_ = _tmp123_;
#line 332 "../src/PlaybackManager.vala"
								_tmp125_ = self->priv->_current_media;
#line 332 "../src/PlaybackManager.vala"
								_tmp126_ = noise_media_get_artist (_tmp125_);
#line 332 "../src/PlaybackManager.vala"
								_tmp127_ = _tmp126_;
#line 332 "../src/PlaybackManager.vala"
								_tmp128_ = !(g_strcmp0 (_tmp124_, _tmp127_) == 0);
#line 332 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp122_);
#line 332 "../src/PlaybackManager.vala"
								if (_tmp128_) {
#line 332 "../src/PlaybackManager.vala"
									break;
#line 1719 "PlaybackManager.c"
								}
#line 333 "../src/PlaybackManager.vala"
								_tmp129_ = self->priv->_current_index;
#line 333 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp129_ - 1;
#line 1725 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp130_ = FALSE;
							NoiseSettingsMain* _tmp131_;
							NoiseSettingsRepeat _tmp132_;
							NoiseSettingsRepeat _tmp133_;
#line 335 "../src/PlaybackManager.vala"
							_tmp131_ = main_settings;
#line 335 "../src/PlaybackManager.vala"
							_tmp132_ = noise_settings_main_get_repeat_mode (_tmp131_);
#line 335 "../src/PlaybackManager.vala"
							_tmp133_ = _tmp132_;
#line 335 "../src/PlaybackManager.vala"
							if (_tmp133_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1740 "PlaybackManager.c"
								NoiseMedia* _tmp134_;
								const gchar* _tmp135_;
								const gchar* _tmp136_;
								NoiseMedia* _tmp137_;
								const gchar* _tmp138_;
								const gchar* _tmp139_;
#line 335 "../src/PlaybackManager.vala"
								_tmp134_ = next_current;
#line 335 "../src/PlaybackManager.vala"
								_tmp135_ = noise_media_get_album (_tmp134_);
#line 335 "../src/PlaybackManager.vala"
								_tmp136_ = _tmp135_;
#line 335 "../src/PlaybackManager.vala"
								_tmp137_ = now_current;
#line 335 "../src/PlaybackManager.vala"
								_tmp138_ = noise_media_get_album (_tmp137_);
#line 335 "../src/PlaybackManager.vala"
								_tmp139_ = _tmp138_;
#line 335 "../src/PlaybackManager.vala"
								_tmp130_ = g_strcmp0 (_tmp136_, _tmp139_) != 0;
#line 1761 "PlaybackManager.c"
							} else {
#line 335 "../src/PlaybackManager.vala"
								_tmp130_ = FALSE;
#line 1765 "PlaybackManager.c"
							}
#line 335 "../src/PlaybackManager.vala"
							if (_tmp130_) {
#line 336 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1771 "PlaybackManager.c"
									GeeHashMap* _tmp140_;
									gpointer _tmp141_;
									NoiseMedia* _tmp142_;
									const gchar* _tmp143_;
									const gchar* _tmp144_;
									NoiseMedia* _tmp145_;
									const gchar* _tmp146_;
									const gchar* _tmp147_;
									gboolean _tmp148_;
									gint _tmp149_;
#line 336 "../src/PlaybackManager.vala"
									_tmp140_ = self->priv->_current;
#line 336 "../src/PlaybackManager.vala"
									_tmp141_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp140_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 336 "../src/PlaybackManager.vala"
									_tmp142_ = (NoiseMedia*) _tmp141_;
#line 336 "../src/PlaybackManager.vala"
									_tmp143_ = noise_media_get_album (_tmp142_);
#line 336 "../src/PlaybackManager.vala"
									_tmp144_ = _tmp143_;
#line 336 "../src/PlaybackManager.vala"
									_tmp145_ = self->priv->_current_media;
#line 336 "../src/PlaybackManager.vala"
									_tmp146_ = noise_media_get_album (_tmp145_);
#line 336 "../src/PlaybackManager.vala"
									_tmp147_ = _tmp146_;
#line 336 "../src/PlaybackManager.vala"
									_tmp148_ = !(g_strcmp0 (_tmp144_, _tmp147_) == 0);
#line 336 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp142_);
#line 336 "../src/PlaybackManager.vala"
									if (_tmp148_) {
#line 336 "../src/PlaybackManager.vala"
										break;
#line 1806 "PlaybackManager.c"
									}
#line 337 "../src/PlaybackManager.vala"
									_tmp149_ = self->priv->_current_index;
#line 337 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp149_ - 1;
#line 1812 "PlaybackManager.c"
								}
							} else {
								gint _tmp150_;
#line 340 "../src/PlaybackManager.vala"
								_tmp150_ = self->priv->_current_index;
#line 340 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp150_ + 1;
#line 1820 "PlaybackManager.c"
							}
						}
#line 343 "../src/PlaybackManager.vala"
						_tmp151_ = self->priv->_current;
#line 343 "../src/PlaybackManager.vala"
						_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp151_, (gpointer) ((gintptr) self->priv->_current_index));
#line 343 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 343 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp152_;
#line 326 "../src/PlaybackManager.vala"
						_g_object_unref0 (now_current);
#line 326 "../src/PlaybackManager.vala"
						_g_object_unref0 (next_current);
#line 1835 "PlaybackManager.c"
					} else {
						NoiseLibrary* _tmp153_;
						NoiseLibrary* _tmp154_;
						GeeCollection* _tmp155_;
						GeeCollection* _tmp156_;
						GeeHashMap* _tmp157_;
						gpointer _tmp158_;
#line 345 "../src/PlaybackManager.vala"
						_tmp153_ = noise_playback_manager_get_library (self);
#line 345 "../src/PlaybackManager.vala"
						_tmp154_ = _tmp153_;
#line 345 "../src/PlaybackManager.vala"
						_tmp155_ = noise_library_get_medias (_tmp154_);
#line 345 "../src/PlaybackManager.vala"
						_tmp156_ = _tmp155_;
#line 345 "../src/PlaybackManager.vala"
						noise_playback_manager_queue_media (self, _tmp156_);
#line 345 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp156_);
#line 347 "../src/PlaybackManager.vala"
						self->priv->_current_index = 0;
#line 348 "../src/PlaybackManager.vala"
						_tmp157_ = self->priv->_current;
#line 348 "../src/PlaybackManager.vala"
						_tmp158_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp157_, (gpointer) ((gintptr) 0));
#line 348 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 348 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp158_;
#line 1865 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 352 "../src/PlaybackManager.vala"
	_tmp159_ = self->queue_playlist;
#line 352 "../src/PlaybackManager.vala"
	_tmp160_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp159_);
#line 352 "../src/PlaybackManager.vala"
	_tmp161_ = _tmp160_;
#line 352 "../src/PlaybackManager.vala"
	_tmp162_ = rv;
#line 352 "../src/PlaybackManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp161_, _tmp162_)) {
#line 353 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 1883 "PlaybackManager.c"
	}
#line 356 "../src/PlaybackManager.vala"
	if (play) {
#line 1887 "PlaybackManager.c"
		NoiseMedia* _tmp163_;
#line 357 "../src/PlaybackManager.vala"
		_tmp163_ = rv;
#line 357 "../src/PlaybackManager.vala"
		noise_playback_manager_play_media (self, _tmp163_);
#line 1893 "PlaybackManager.c"
	}
#line 360 "../src/PlaybackManager.vala"
	result = rv;
#line 360 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 360 "../src/PlaybackManager.vala"
	return result;
#line 1901 "PlaybackManager.c"
}

NoiseMedia*
noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                     gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseStaticPlaylist* _tmp173_;
	GeeArrayList* _tmp174_;
	GeeArrayList* _tmp175_;
	NoiseMedia* _tmp176_;
#line 364 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 365 "../src/PlaybackManager.vala"
	rv = NULL;
#line 367 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 367 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 368 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 368 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 368 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 368 "../src/PlaybackManager.vala"
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 1935 "PlaybackManager.c"
		GeeHashMap* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		NoiseMedia* _tmp14_;
#line 369 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 369 "../src/PlaybackManager.vala"
		_tmp5_ = gee_map_get_is_empty ((GeeMap*) _tmp4_);
#line 369 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 369 "../src/PlaybackManager.vala"
		if (_tmp6_) {
#line 1948 "PlaybackManager.c"
			GeeHashMap* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 370 "../src/PlaybackManager.vala"
			_tmp7_ = self->priv->_current;
#line 370 "../src/PlaybackManager.vala"
			_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
#line 370 "../src/PlaybackManager.vala"
			_tmp9_ = _tmp8_;
#line 370 "../src/PlaybackManager.vala"
			if (_tmp9_) {
#line 1960 "PlaybackManager.c"
				NoiseLibrary* _tmp10_;
				NoiseLibrary* _tmp11_;
				GeeCollection* _tmp12_;
				GeeCollection* _tmp13_;
#line 371 "../src/PlaybackManager.vala"
				_tmp10_ = noise_playback_manager_get_library (self);
#line 371 "../src/PlaybackManager.vala"
				_tmp11_ = _tmp10_;
#line 371 "../src/PlaybackManager.vala"
				_tmp12_ = noise_library_get_medias (_tmp11_);
#line 371 "../src/PlaybackManager.vala"
				_tmp13_ = _tmp12_;
#line 371 "../src/PlaybackManager.vala"
				noise_playback_manager_queue_media (self, _tmp13_);
#line 371 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp13_);
#line 1977 "PlaybackManager.c"
			}
#line 374 "../src/PlaybackManager.vala"
			noise_playback_manager_reshuffle (self);
#line 1981 "PlaybackManager.c"
		}
#line 377 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 379 "../src/PlaybackManager.vala"
		_tmp14_ = self->priv->_current_media;
#line 379 "../src/PlaybackManager.vala"
		if (_tmp14_ == NULL) {
#line 1989 "PlaybackManager.c"
			GeeHashMap* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
#line 380 "../src/PlaybackManager.vala"
			_tmp15_ = self->priv->_current_shuffled;
#line 380 "../src/PlaybackManager.vala"
			_tmp16_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp15_);
#line 380 "../src/PlaybackManager.vala"
			_tmp17_ = _tmp16_;
#line 380 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = _tmp17_ - 1;
#line 381 "../src/PlaybackManager.vala"
			_tmp18_ = self->priv->_current_shuffled;
#line 381 "../src/PlaybackManager.vala"
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 381 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 381 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp19_;
#line 2011 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp20_;
			NoiseSettingsRepeat _tmp21_;
			NoiseSettingsRepeat _tmp22_;
#line 382 "../src/PlaybackManager.vala"
			_tmp20_ = main_settings;
#line 382 "../src/PlaybackManager.vala"
			_tmp21_ = noise_settings_main_get_repeat_mode (_tmp20_);
#line 382 "../src/PlaybackManager.vala"
			_tmp22_ = _tmp21_;
#line 382 "../src/PlaybackManager.vala"
			if (_tmp22_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2024 "PlaybackManager.c"
				GeeHashMap* _tmp23_;
				gpointer _tmp24_;
#line 383 "../src/PlaybackManager.vala"
				_tmp23_ = self->priv->_current_shuffled;
#line 383 "../src/PlaybackManager.vala"
				_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 383 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 383 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp24_;
#line 2035 "PlaybackManager.c"
			} else {
#line 384 "../src/PlaybackManager.vala"
				if (self->priv->_current_shuffled_index == 0) {
#line 2039 "PlaybackManager.c"
					NoiseSettingsMain* _tmp25_;
					NoiseSettingsRepeat _tmp26_;
					NoiseSettingsRepeat _tmp27_;
					GeeHashMap* _tmp31_;
					gpointer _tmp32_;
#line 385 "../src/PlaybackManager.vala"
					_tmp25_ = main_settings;
#line 385 "../src/PlaybackManager.vala"
					_tmp26_ = noise_settings_main_get_repeat_mode (_tmp25_);
#line 385 "../src/PlaybackManager.vala"
					_tmp27_ = _tmp26_;
#line 385 "../src/PlaybackManager.vala"
					if (_tmp27_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2053 "PlaybackManager.c"
						GeeHashMap* _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
#line 386 "../src/PlaybackManager.vala"
						_tmp28_ = self->priv->_current_shuffled;
#line 386 "../src/PlaybackManager.vala"
						_tmp29_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp28_);
#line 386 "../src/PlaybackManager.vala"
						_tmp30_ = _tmp29_;
#line 386 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp30_ - 1;
#line 2065 "PlaybackManager.c"
					} else {
#line 388 "../src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 389 "../src/PlaybackManager.vala"
						result = NULL;
#line 389 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 389 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 389 "../src/PlaybackManager.vala"
						return result;
#line 2077 "PlaybackManager.c"
					}
#line 392 "../src/PlaybackManager.vala"
					_tmp31_ = self->priv->_current_shuffled;
#line 392 "../src/PlaybackManager.vala"
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 392 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 392 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp32_;
#line 2087 "PlaybackManager.c"
				} else {
					gboolean _tmp33_ = FALSE;
#line 393 "../src/PlaybackManager.vala"
					if (self->priv->_current_shuffled_index > 0) {
#line 2092 "PlaybackManager.c"
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
#line 393 "../src/PlaybackManager.vala"
						_tmp34_ = self->priv->_current_shuffled;
#line 393 "../src/PlaybackManager.vala"
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
#line 393 "../src/PlaybackManager.vala"
						_tmp36_ = _tmp35_;
#line 393 "../src/PlaybackManager.vala"
						_tmp33_ = self->priv->_current_shuffled_index < _tmp36_;
#line 2104 "PlaybackManager.c"
					} else {
#line 393 "../src/PlaybackManager.vala"
						_tmp33_ = FALSE;
#line 2108 "PlaybackManager.c"
					}
#line 393 "../src/PlaybackManager.vala"
					if (_tmp33_) {
#line 2112 "PlaybackManager.c"
						gboolean _tmp37_ = FALSE;
						NoiseSettingsMain* _tmp38_;
						NoiseSettingsRepeat _tmp39_;
						NoiseSettingsRepeat _tmp40_;
						GeeHashMap* _tmp83_;
						gpointer _tmp84_;
#line 395 "../src/PlaybackManager.vala"
						_tmp38_ = main_settings;
#line 395 "../src/PlaybackManager.vala"
						_tmp39_ = noise_settings_main_get_repeat_mode (_tmp38_);
#line 395 "../src/PlaybackManager.vala"
						_tmp40_ = _tmp39_;
#line 395 "../src/PlaybackManager.vala"
						if (_tmp40_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2127 "PlaybackManager.c"
							GeeHashMap* _tmp41_;
							gpointer _tmp42_;
							NoiseMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
							GeeHashMap* _tmp46_;
							gpointer _tmp47_;
							NoiseMedia* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
#line 395 "../src/PlaybackManager.vala"
							_tmp41_ = self->priv->_current_shuffled;
#line 395 "../src/PlaybackManager.vala"
							_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 395 "../src/PlaybackManager.vala"
							_tmp43_ = (NoiseMedia*) _tmp42_;
#line 395 "../src/PlaybackManager.vala"
							_tmp44_ = noise_media_get_artist (_tmp43_);
#line 395 "../src/PlaybackManager.vala"
							_tmp45_ = _tmp44_;
#line 395 "../src/PlaybackManager.vala"
							_tmp46_ = self->priv->_current_shuffled;
#line 395 "../src/PlaybackManager.vala"
							_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 395 "../src/PlaybackManager.vala"
							_tmp48_ = (NoiseMedia*) _tmp47_;
#line 395 "../src/PlaybackManager.vala"
							_tmp49_ = noise_media_get_artist (_tmp48_);
#line 395 "../src/PlaybackManager.vala"
							_tmp50_ = _tmp49_;
#line 395 "../src/PlaybackManager.vala"
							_tmp37_ = g_strcmp0 (_tmp45_, _tmp50_) != 0;
#line 395 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp48_);
#line 395 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp43_);
#line 2164 "PlaybackManager.c"
						} else {
#line 395 "../src/PlaybackManager.vala"
							_tmp37_ = FALSE;
#line 2168 "PlaybackManager.c"
						}
#line 395 "../src/PlaybackManager.vala"
						if (_tmp37_) {
#line 396 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2174 "PlaybackManager.c"
								GeeHashMap* _tmp51_;
								gpointer _tmp52_;
								NoiseMedia* _tmp53_;
								const gchar* _tmp54_;
								const gchar* _tmp55_;
								NoiseMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
#line 396 "../src/PlaybackManager.vala"
								_tmp51_ = self->priv->_current_shuffled;
#line 396 "../src/PlaybackManager.vala"
								_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
#line 396 "../src/PlaybackManager.vala"
								_tmp53_ = (NoiseMedia*) _tmp52_;
#line 396 "../src/PlaybackManager.vala"
								_tmp54_ = noise_media_get_artist (_tmp53_);
#line 396 "../src/PlaybackManager.vala"
								_tmp55_ = _tmp54_;
#line 396 "../src/PlaybackManager.vala"
								_tmp56_ = self->priv->_current_media;
#line 396 "../src/PlaybackManager.vala"
								_tmp57_ = noise_media_get_artist (_tmp56_);
#line 396 "../src/PlaybackManager.vala"
								_tmp58_ = _tmp57_;
#line 396 "../src/PlaybackManager.vala"
								_tmp59_ = !(g_strcmp0 (_tmp55_, _tmp58_) == 0);
#line 396 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp53_);
#line 396 "../src/PlaybackManager.vala"
								if (_tmp59_) {
#line 396 "../src/PlaybackManager.vala"
									break;
#line 2208 "PlaybackManager.c"
								}
#line 397 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
#line 2212 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp60_ = FALSE;
							NoiseSettingsMain* _tmp61_;
							NoiseSettingsRepeat _tmp62_;
							NoiseSettingsRepeat _tmp63_;
#line 398 "../src/PlaybackManager.vala"
							_tmp61_ = main_settings;
#line 398 "../src/PlaybackManager.vala"
							_tmp62_ = noise_settings_main_get_repeat_mode (_tmp61_);
#line 398 "../src/PlaybackManager.vala"
							_tmp63_ = _tmp62_;
#line 398 "../src/PlaybackManager.vala"
							if (_tmp63_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2227 "PlaybackManager.c"
								GeeHashMap* _tmp64_;
								gpointer _tmp65_;
								NoiseMedia* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								GeeHashMap* _tmp69_;
								gpointer _tmp70_;
								NoiseMedia* _tmp71_;
								const gchar* _tmp72_;
								const gchar* _tmp73_;
#line 398 "../src/PlaybackManager.vala"
								_tmp64_ = self->priv->_current_shuffled;
#line 398 "../src/PlaybackManager.vala"
								_tmp65_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
#line 398 "../src/PlaybackManager.vala"
								_tmp66_ = (NoiseMedia*) _tmp65_;
#line 398 "../src/PlaybackManager.vala"
								_tmp67_ = noise_media_get_album (_tmp66_);
#line 398 "../src/PlaybackManager.vala"
								_tmp68_ = _tmp67_;
#line 398 "../src/PlaybackManager.vala"
								_tmp69_ = self->priv->_current_shuffled;
#line 398 "../src/PlaybackManager.vala"
								_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 398 "../src/PlaybackManager.vala"
								_tmp71_ = (NoiseMedia*) _tmp70_;
#line 398 "../src/PlaybackManager.vala"
								_tmp72_ = noise_media_get_album (_tmp71_);
#line 398 "../src/PlaybackManager.vala"
								_tmp73_ = _tmp72_;
#line 398 "../src/PlaybackManager.vala"
								_tmp60_ = g_strcmp0 (_tmp68_, _tmp73_) != 0;
#line 398 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp71_);
#line 398 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp66_);
#line 2264 "PlaybackManager.c"
							} else {
#line 398 "../src/PlaybackManager.vala"
								_tmp60_ = FALSE;
#line 2268 "PlaybackManager.c"
							}
#line 398 "../src/PlaybackManager.vala"
							if (_tmp60_) {
#line 399 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2274 "PlaybackManager.c"
									GeeHashMap* _tmp74_;
									gpointer _tmp75_;
									NoiseMedia* _tmp76_;
									const gchar* _tmp77_;
									const gchar* _tmp78_;
									NoiseMedia* _tmp79_;
									const gchar* _tmp80_;
									const gchar* _tmp81_;
									gboolean _tmp82_;
#line 399 "../src/PlaybackManager.vala"
									_tmp74_ = self->priv->_current_shuffled;
#line 399 "../src/PlaybackManager.vala"
									_tmp75_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp74_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
#line 399 "../src/PlaybackManager.vala"
									_tmp76_ = (NoiseMedia*) _tmp75_;
#line 399 "../src/PlaybackManager.vala"
									_tmp77_ = noise_media_get_album (_tmp76_);
#line 399 "../src/PlaybackManager.vala"
									_tmp78_ = _tmp77_;
#line 399 "../src/PlaybackManager.vala"
									_tmp79_ = self->priv->_current_media;
#line 399 "../src/PlaybackManager.vala"
									_tmp80_ = noise_media_get_album (_tmp79_);
#line 399 "../src/PlaybackManager.vala"
									_tmp81_ = _tmp80_;
#line 399 "../src/PlaybackManager.vala"
									_tmp82_ = !(g_strcmp0 (_tmp78_, _tmp81_) == 0);
#line 399 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp76_);
#line 399 "../src/PlaybackManager.vala"
									if (_tmp82_) {
#line 399 "../src/PlaybackManager.vala"
										break;
#line 2308 "PlaybackManager.c"
									}
#line 400 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
#line 2312 "PlaybackManager.c"
								}
							} else {
#line 402 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index - 1;
#line 2317 "PlaybackManager.c"
							}
						}
#line 404 "../src/PlaybackManager.vala"
						_tmp83_ = self->priv->_current_shuffled;
#line 404 "../src/PlaybackManager.vala"
						_tmp84_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp83_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 404 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 404 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp84_;
#line 2328 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp85_;
						gint _tmp86_;
						gint _tmp87_;
						GeeHashMap* _tmp88_;
						gpointer _tmp89_;
#line 406 "../src/PlaybackManager.vala"
						_tmp85_ = self->priv->_current_shuffled;
#line 406 "../src/PlaybackManager.vala"
						_tmp86_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp85_);
#line 406 "../src/PlaybackManager.vala"
						_tmp87_ = _tmp86_;
#line 406 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp87_ - 1;
#line 407 "../src/PlaybackManager.vala"
						_tmp88_ = self->priv->_current_shuffled;
#line 407 "../src/PlaybackManager.vala"
						_tmp89_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp88_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
#line 407 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 407 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp89_;
#line 2351 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp90_;
#line 410 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 412 "../src/PlaybackManager.vala"
		_tmp90_ = self->priv->_current_media;
#line 412 "../src/PlaybackManager.vala"
		if (_tmp90_ == NULL) {
#line 2364 "PlaybackManager.c"
			GeeHashMap* _tmp91_;
			gint _tmp92_;
			gint _tmp93_;
			GeeHashMap* _tmp94_;
			gpointer _tmp95_;
#line 413 "../src/PlaybackManager.vala"
			_tmp91_ = self->priv->_current;
#line 413 "../src/PlaybackManager.vala"
			_tmp92_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp91_);
#line 413 "../src/PlaybackManager.vala"
			_tmp93_ = _tmp92_;
#line 413 "../src/PlaybackManager.vala"
			self->priv->_current_index = _tmp93_ - 1;
#line 414 "../src/PlaybackManager.vala"
			_tmp94_ = self->priv->_current;
#line 414 "../src/PlaybackManager.vala"
			_tmp95_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp94_, (gpointer) ((gintptr) self->priv->_current_index));
#line 414 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 414 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp95_;
#line 2386 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp96_;
			NoiseSettingsRepeat _tmp97_;
			NoiseSettingsRepeat _tmp98_;
#line 415 "../src/PlaybackManager.vala"
			_tmp96_ = main_settings;
#line 415 "../src/PlaybackManager.vala"
			_tmp97_ = noise_settings_main_get_repeat_mode (_tmp96_);
#line 415 "../src/PlaybackManager.vala"
			_tmp98_ = _tmp97_;
#line 415 "../src/PlaybackManager.vala"
			if (_tmp98_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2399 "PlaybackManager.c"
				GeeHashMap* _tmp99_;
				gpointer _tmp100_;
#line 416 "../src/PlaybackManager.vala"
				_tmp99_ = self->priv->_current;
#line 416 "../src/PlaybackManager.vala"
				_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) self->priv->_current_index));
#line 416 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 416 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp100_;
#line 2410 "PlaybackManager.c"
			} else {
#line 417 "../src/PlaybackManager.vala"
				if (self->priv->_current_index == 0) {
#line 2414 "PlaybackManager.c"
					NoiseSettingsMain* _tmp101_;
					NoiseSettingsRepeat _tmp102_;
					NoiseSettingsRepeat _tmp103_;
					GeeHashMap* _tmp107_;
					gpointer _tmp108_;
#line 418 "../src/PlaybackManager.vala"
					_tmp101_ = main_settings;
#line 418 "../src/PlaybackManager.vala"
					_tmp102_ = noise_settings_main_get_repeat_mode (_tmp101_);
#line 418 "../src/PlaybackManager.vala"
					_tmp103_ = _tmp102_;
#line 418 "../src/PlaybackManager.vala"
					if (_tmp103_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2428 "PlaybackManager.c"
						GeeHashMap* _tmp104_;
						gint _tmp105_;
						gint _tmp106_;
#line 419 "../src/PlaybackManager.vala"
						_tmp104_ = self->priv->_current;
#line 419 "../src/PlaybackManager.vala"
						_tmp105_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp104_);
#line 419 "../src/PlaybackManager.vala"
						_tmp106_ = _tmp105_;
#line 419 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp106_ - 1;
#line 2440 "PlaybackManager.c"
					} else {
#line 421 "../src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 422 "../src/PlaybackManager.vala"
						result = NULL;
#line 422 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 422 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 422 "../src/PlaybackManager.vala"
						return result;
#line 2452 "PlaybackManager.c"
					}
#line 425 "../src/PlaybackManager.vala"
					_tmp107_ = self->priv->_current;
#line 425 "../src/PlaybackManager.vala"
					_tmp108_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp107_, (gpointer) ((gintptr) self->priv->_current_index));
#line 425 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 425 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp108_;
#line 2462 "PlaybackManager.c"
				} else {
					gboolean _tmp109_ = FALSE;
#line 426 "../src/PlaybackManager.vala"
					if (self->priv->_current_index > 0) {
#line 2467 "PlaybackManager.c"
						GeeHashMap* _tmp110_;
						gint _tmp111_;
						gint _tmp112_;
#line 426 "../src/PlaybackManager.vala"
						_tmp110_ = self->priv->_current;
#line 426 "../src/PlaybackManager.vala"
						_tmp111_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp110_);
#line 426 "../src/PlaybackManager.vala"
						_tmp112_ = _tmp111_;
#line 426 "../src/PlaybackManager.vala"
						_tmp109_ = self->priv->_current_index < _tmp112_;
#line 2479 "PlaybackManager.c"
					} else {
#line 426 "../src/PlaybackManager.vala"
						_tmp109_ = FALSE;
#line 2483 "PlaybackManager.c"
					}
#line 426 "../src/PlaybackManager.vala"
					if (_tmp109_) {
#line 2487 "PlaybackManager.c"
						gboolean _tmp113_ = FALSE;
						NoiseSettingsMain* _tmp114_;
						NoiseSettingsRepeat _tmp115_;
						NoiseSettingsRepeat _tmp116_;
						GeeHashMap* _tmp162_;
						gpointer _tmp163_;
#line 428 "../src/PlaybackManager.vala"
						_tmp114_ = main_settings;
#line 428 "../src/PlaybackManager.vala"
						_tmp115_ = noise_settings_main_get_repeat_mode (_tmp114_);
#line 428 "../src/PlaybackManager.vala"
						_tmp116_ = _tmp115_;
#line 428 "../src/PlaybackManager.vala"
						if (_tmp116_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2502 "PlaybackManager.c"
							GeeHashMap* _tmp117_;
							gpointer _tmp118_;
							NoiseMedia* _tmp119_;
							const gchar* _tmp120_;
							const gchar* _tmp121_;
							GeeHashMap* _tmp122_;
							gpointer _tmp123_;
							NoiseMedia* _tmp124_;
							const gchar* _tmp125_;
							const gchar* _tmp126_;
#line 428 "../src/PlaybackManager.vala"
							_tmp117_ = self->priv->_current;
#line 428 "../src/PlaybackManager.vala"
							_tmp118_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp117_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 428 "../src/PlaybackManager.vala"
							_tmp119_ = (NoiseMedia*) _tmp118_;
#line 428 "../src/PlaybackManager.vala"
							_tmp120_ = noise_media_get_artist (_tmp119_);
#line 428 "../src/PlaybackManager.vala"
							_tmp121_ = _tmp120_;
#line 428 "../src/PlaybackManager.vala"
							_tmp122_ = self->priv->_current;
#line 428 "../src/PlaybackManager.vala"
							_tmp123_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp122_, (gpointer) ((gintptr) self->priv->_current_index));
#line 428 "../src/PlaybackManager.vala"
							_tmp124_ = (NoiseMedia*) _tmp123_;
#line 428 "../src/PlaybackManager.vala"
							_tmp125_ = noise_media_get_artist (_tmp124_);
#line 428 "../src/PlaybackManager.vala"
							_tmp126_ = _tmp125_;
#line 428 "../src/PlaybackManager.vala"
							_tmp113_ = g_strcmp0 (_tmp121_, _tmp126_) != 0;
#line 428 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp124_);
#line 428 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp119_);
#line 2539 "PlaybackManager.c"
						} else {
#line 428 "../src/PlaybackManager.vala"
							_tmp113_ = FALSE;
#line 2543 "PlaybackManager.c"
						}
#line 428 "../src/PlaybackManager.vala"
						if (_tmp113_) {
#line 429 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2549 "PlaybackManager.c"
								GeeHashMap* _tmp127_;
								gpointer _tmp128_;
								NoiseMedia* _tmp129_;
								const gchar* _tmp130_;
								const gchar* _tmp131_;
								NoiseMedia* _tmp132_;
								const gchar* _tmp133_;
								const gchar* _tmp134_;
								gboolean _tmp135_;
								gint _tmp136_;
#line 429 "../src/PlaybackManager.vala"
								_tmp127_ = self->priv->_current;
#line 429 "../src/PlaybackManager.vala"
								_tmp128_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp127_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
#line 429 "../src/PlaybackManager.vala"
								_tmp129_ = (NoiseMedia*) _tmp128_;
#line 429 "../src/PlaybackManager.vala"
								_tmp130_ = noise_media_get_artist (_tmp129_);
#line 429 "../src/PlaybackManager.vala"
								_tmp131_ = _tmp130_;
#line 429 "../src/PlaybackManager.vala"
								_tmp132_ = self->priv->_current_media;
#line 429 "../src/PlaybackManager.vala"
								_tmp133_ = noise_media_get_artist (_tmp132_);
#line 429 "../src/PlaybackManager.vala"
								_tmp134_ = _tmp133_;
#line 429 "../src/PlaybackManager.vala"
								_tmp135_ = !(g_strcmp0 (_tmp131_, _tmp134_) == 0);
#line 429 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp129_);
#line 429 "../src/PlaybackManager.vala"
								if (_tmp135_) {
#line 429 "../src/PlaybackManager.vala"
									break;
#line 2584 "PlaybackManager.c"
								}
#line 430 "../src/PlaybackManager.vala"
								_tmp136_ = self->priv->_current_index;
#line 430 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp136_ + 1;
#line 2590 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp137_ = FALSE;
							NoiseSettingsMain* _tmp138_;
							NoiseSettingsRepeat _tmp139_;
							NoiseSettingsRepeat _tmp140_;
#line 431 "../src/PlaybackManager.vala"
							_tmp138_ = main_settings;
#line 431 "../src/PlaybackManager.vala"
							_tmp139_ = noise_settings_main_get_repeat_mode (_tmp138_);
#line 431 "../src/PlaybackManager.vala"
							_tmp140_ = _tmp139_;
#line 431 "../src/PlaybackManager.vala"
							if (_tmp140_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2605 "PlaybackManager.c"
								GeeHashMap* _tmp141_;
								gpointer _tmp142_;
								NoiseMedia* _tmp143_;
								const gchar* _tmp144_;
								const gchar* _tmp145_;
								GeeHashMap* _tmp146_;
								gpointer _tmp147_;
								NoiseMedia* _tmp148_;
								const gchar* _tmp149_;
								const gchar* _tmp150_;
#line 431 "../src/PlaybackManager.vala"
								_tmp141_ = self->priv->_current;
#line 431 "../src/PlaybackManager.vala"
								_tmp142_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp141_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
#line 431 "../src/PlaybackManager.vala"
								_tmp143_ = (NoiseMedia*) _tmp142_;
#line 431 "../src/PlaybackManager.vala"
								_tmp144_ = noise_media_get_album (_tmp143_);
#line 431 "../src/PlaybackManager.vala"
								_tmp145_ = _tmp144_;
#line 431 "../src/PlaybackManager.vala"
								_tmp146_ = self->priv->_current;
#line 431 "../src/PlaybackManager.vala"
								_tmp147_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp146_, (gpointer) ((gintptr) self->priv->_current_index));
#line 431 "../src/PlaybackManager.vala"
								_tmp148_ = (NoiseMedia*) _tmp147_;
#line 431 "../src/PlaybackManager.vala"
								_tmp149_ = noise_media_get_album (_tmp148_);
#line 431 "../src/PlaybackManager.vala"
								_tmp150_ = _tmp149_;
#line 431 "../src/PlaybackManager.vala"
								_tmp137_ = g_strcmp0 (_tmp145_, _tmp150_) != 0;
#line 431 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp148_);
#line 431 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp143_);
#line 2642 "PlaybackManager.c"
							} else {
#line 431 "../src/PlaybackManager.vala"
								_tmp137_ = FALSE;
#line 2646 "PlaybackManager.c"
							}
#line 431 "../src/PlaybackManager.vala"
							if (_tmp137_) {
#line 432 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2652 "PlaybackManager.c"
									GeeHashMap* _tmp151_;
									gpointer _tmp152_;
									NoiseMedia* _tmp153_;
									const gchar* _tmp154_;
									const gchar* _tmp155_;
									NoiseMedia* _tmp156_;
									const gchar* _tmp157_;
									const gchar* _tmp158_;
									gboolean _tmp159_;
									gint _tmp160_;
#line 432 "../src/PlaybackManager.vala"
									_tmp151_ = self->priv->_current;
#line 432 "../src/PlaybackManager.vala"
									_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp151_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
#line 432 "../src/PlaybackManager.vala"
									_tmp153_ = (NoiseMedia*) _tmp152_;
#line 432 "../src/PlaybackManager.vala"
									_tmp154_ = noise_media_get_album (_tmp153_);
#line 432 "../src/PlaybackManager.vala"
									_tmp155_ = _tmp154_;
#line 432 "../src/PlaybackManager.vala"
									_tmp156_ = self->priv->_current_media;
#line 432 "../src/PlaybackManager.vala"
									_tmp157_ = noise_media_get_album (_tmp156_);
#line 432 "../src/PlaybackManager.vala"
									_tmp158_ = _tmp157_;
#line 432 "../src/PlaybackManager.vala"
									_tmp159_ = !(g_strcmp0 (_tmp155_, _tmp158_) == 0);
#line 432 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp153_);
#line 432 "../src/PlaybackManager.vala"
									if (_tmp159_) {
#line 432 "../src/PlaybackManager.vala"
										break;
#line 2687 "PlaybackManager.c"
									}
#line 433 "../src/PlaybackManager.vala"
									_tmp160_ = self->priv->_current_index;
#line 433 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp160_ + 1;
#line 2693 "PlaybackManager.c"
								}
							} else {
								gint _tmp161_;
#line 435 "../src/PlaybackManager.vala"
								_tmp161_ = self->priv->_current_index;
#line 435 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp161_ - 1;
#line 2701 "PlaybackManager.c"
							}
						}
#line 438 "../src/PlaybackManager.vala"
						_tmp162_ = self->priv->_current;
#line 438 "../src/PlaybackManager.vala"
						_tmp163_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp162_, (gpointer) ((gintptr) self->priv->_current_index));
#line 438 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 438 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp163_;
#line 2712 "PlaybackManager.c"
					} else {
						NoiseLibrary* _tmp164_;
						NoiseLibrary* _tmp165_;
						GeeCollection* _tmp166_;
						GeeCollection* _tmp167_;
						GeeHashMap* _tmp168_;
						gint _tmp169_;
						gint _tmp170_;
						GeeHashMap* _tmp171_;
						gpointer _tmp172_;
#line 440 "../src/PlaybackManager.vala"
						_tmp164_ = noise_playback_manager_get_library (self);
#line 440 "../src/PlaybackManager.vala"
						_tmp165_ = _tmp164_;
#line 440 "../src/PlaybackManager.vala"
						_tmp166_ = noise_library_get_medias (_tmp165_);
#line 440 "../src/PlaybackManager.vala"
						_tmp167_ = _tmp166_;
#line 440 "../src/PlaybackManager.vala"
						noise_playback_manager_queue_media (self, _tmp167_);
#line 440 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp167_);
#line 442 "../src/PlaybackManager.vala"
						_tmp168_ = self->priv->_current;
#line 442 "../src/PlaybackManager.vala"
						_tmp169_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp168_);
#line 442 "../src/PlaybackManager.vala"
						_tmp170_ = _tmp169_;
#line 442 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp170_ - 1;
#line 443 "../src/PlaybackManager.vala"
						_tmp171_ = self->priv->_current;
#line 443 "../src/PlaybackManager.vala"
						_tmp172_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp171_, (gpointer) ((gintptr) self->priv->_current_index));
#line 443 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 443 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp172_;
#line 2751 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 447 "../src/PlaybackManager.vala"
	_tmp173_ = self->queue_playlist;
#line 447 "../src/PlaybackManager.vala"
	_tmp174_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp173_);
#line 447 "../src/PlaybackManager.vala"
	_tmp175_ = _tmp174_;
#line 447 "../src/PlaybackManager.vala"
	_tmp176_ = rv;
#line 447 "../src/PlaybackManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp175_, _tmp176_)) {
#line 448 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 2769 "PlaybackManager.c"
	}
#line 451 "../src/PlaybackManager.vala"
	if (play) {
#line 2773 "PlaybackManager.c"
		NoiseMedia* _tmp177_;
#line 452 "../src/PlaybackManager.vala"
		_tmp177_ = rv;
#line 452 "../src/PlaybackManager.vala"
		noise_playback_manager_play_media (self, _tmp177_);
#line 2779 "PlaybackManager.c"
	}
#line 455 "../src/PlaybackManager.vala"
	result = rv;
#line 455 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 455 "../src/PlaybackManager.vala"
	return result;
#line 2787 "PlaybackManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 458 "../src/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 2795 "PlaybackManager.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 458 "../src/PlaybackManager.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 458 "../src/PlaybackManager.vala"
	return _data10_;
#line 2805 "PlaybackManager.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 458 "../src/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2815 "PlaybackManager.c"
		NoisePlaybackManager* self;
#line 458 "../src/PlaybackManager.vala"
		self = _data10_->self;
#line 458 "../src/PlaybackManager.vala"
		_g_object_unref0 (_data10_->m);
#line 458 "../src/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 458 "../src/PlaybackManager.vala"
		g_slice_free (Block10Data, _data10_);
#line 2825 "PlaybackManager.c"
	}
}

static gboolean
__lambda33_ (Block10Data* _data10_)
{
	NoisePlaybackManager* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 539 "../src/PlaybackManager.vala"
	self = _data10_->self;
#line 540 "../src/PlaybackManager.vala"
	if (_data10_->m != NULL) {
#line 2839 "PlaybackManager.c"
		NoiseMedia* _tmp1_;
#line 540 "../src/PlaybackManager.vala"
		_tmp1_ = self->priv->_current_media;
#line 540 "../src/PlaybackManager.vala"
		_tmp0_ = _tmp1_ == _data10_->m;
#line 2845 "PlaybackManager.c"
	} else {
#line 540 "../src/PlaybackManager.vala"
		_tmp0_ = FALSE;
#line 2849 "PlaybackManager.c"
	}
#line 540 "../src/PlaybackManager.vala"
	if (_tmp0_) {
#line 2853 "PlaybackManager.c"
		NoiseHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		NoisePlayback* _tmp3_;
#line 541 "../src/PlaybackManager.vala"
		_tmp2_ = self->history_playlist;
#line 541 "../src/PlaybackManager.vala"
		noise_playlist_add_media ((NoisePlaylist*) _tmp2_, _data10_->m);
#line 543 "../src/PlaybackManager.vala"
		_tmp3_ = self->player;
#line 543 "../src/PlaybackManager.vala"
		player_duration_s = (guint) (noise_playback_get_duration (_tmp3_) / NOISE_TIME_UTILS_NANO_INV);
#line 544 "../src/PlaybackManager.vala"
		if (player_duration_s > ((guint) 1)) {
#line 2867 "PlaybackManager.c"
			gint delta_s = 0;
			guint _tmp4_;
			guint _tmp5_;
#line 545 "../src/PlaybackManager.vala"
			_tmp4_ = noise_media_get_length (_data10_->m);
#line 545 "../src/PlaybackManager.vala"
			_tmp5_ = _tmp4_;
#line 545 "../src/PlaybackManager.vala"
			delta_s = ((gint) player_duration_s) - ((gint) (_tmp5_ / NOISE_TIME_UTILS_MILI_INV));
#line 546 "../src/PlaybackManager.vala"
			if (fabs ((gdouble) delta_s) > ((gdouble) 3)) {
#line 2879 "PlaybackManager.c"
				NoiseLibrary* _tmp6_;
				NoiseLibrary* _tmp7_;
#line 547 "../src/PlaybackManager.vala"
				noise_media_set_length (_data10_->m, (guint) (player_duration_s * NOISE_TIME_UTILS_MILI_INV));
#line 548 "../src/PlaybackManager.vala"
				_tmp6_ = noise_playback_manager_get_library (self);
#line 548 "../src/PlaybackManager.vala"
				_tmp7_ = _tmp6_;
#line 548 "../src/PlaybackManager.vala"
				noise_library_update_media (_tmp7_, _data10_->m, FALSE, FALSE);
#line 2890 "PlaybackManager.c"
			}
		}
	}
#line 553 "../src/PlaybackManager.vala"
	result = FALSE;
#line 553 "../src/PlaybackManager.vala"
	return result;
#line 2898 "PlaybackManager.c"
}

static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
#line 539 "../src/PlaybackManager.vala"
	return result;
#line 2908 "PlaybackManager.c"
}

void
noise_playback_manager_play_media (NoisePlaybackManager* self,
                                   NoiseMedia* m)
{
	Block10Data* _data10_;
	NoiseMedia* _tmp0_;
	gint64 old_id = 0LL;
	NoiseMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	GFile* _tmp41_;
	GFile* _tmp42_;
	NoisePlayback* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp55_ = FALSE;
	gint64 _tmp56_;
	gint64 _tmp57_;
	GError* _inner_error0_ = NULL;
#line 458 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 458 "../src/PlaybackManager.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 458 "../src/PlaybackManager.vala"
	_data10_->_ref_count_ = 1;
#line 458 "../src/PlaybackManager.vala"
	_data10_->self = g_object_ref (self);
#line 458 "../src/PlaybackManager.vala"
	_tmp0_ = _g_object_ref0 (m);
#line 458 "../src/PlaybackManager.vala"
	_g_object_unref0 (_data10_->m);
#line 458 "../src/PlaybackManager.vala"
	_data10_->m = _tmp0_;
#line 459 "../src/PlaybackManager.vala"
	old_id = (gint64) -1;
#line 462 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 462 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 2952 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 463 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 463 "../src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 463 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 463 "../src/PlaybackManager.vala"
		old_id = _tmp4_;
#line 2964 "PlaybackManager.c"
	}
#line 465 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, _data10_->m);
#line 469 "../src/PlaybackManager.vala"
	_tmp5_ = noise_media_get_location_unknown (_data10_->m);
#line 469 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 469 "../src/PlaybackManager.vala"
	if (_tmp6_) {
#line 2974 "PlaybackManager.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
#line 470 "../src/PlaybackManager.vala"
		_tmp7_ = noise_media_get_uri (_data10_->m);
#line 470 "../src/PlaybackManager.vala"
		_tmp8_ = _tmp7_;
#line 470 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 470 "../src/PlaybackManager.vala"
		_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 470 "../src/PlaybackManager.vala"
		_tmp11_ = _tmp10_;
#line 470 "../src/PlaybackManager.vala"
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
#line 470 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp11_);
#line 470 "../src/PlaybackManager.vala"
		_g_free0 (_tmp9_);
#line 470 "../src/PlaybackManager.vala"
		if (_tmp12_) {
#line 471 "../src/PlaybackManager.vala"
			noise_media_set_location_unknown (_data10_->m, FALSE);
#line 472 "../src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_data10_->m, NULL);
#line 3003 "PlaybackManager.c"
		} else {
#line 475 "../src/PlaybackManager.vala"
			noise_playback_manager_stop_playback (self);
#line 476 "../src/PlaybackManager.vala"
			block10_data_unref (_data10_);
#line 476 "../src/PlaybackManager.vala"
			_data10_ = NULL;
#line 476 "../src/PlaybackManager.vala"
			return;
#line 3013 "PlaybackManager.c"
		}
	}
#line 480 "../src/PlaybackManager.vala"
	found = FALSE;
#line 3018 "PlaybackManager.c"
	{
		GeeTreeSet* _tmp13_;
#line 481 "../src/PlaybackManager.vala"
		_tmp13_ = self->priv->playbacks;
#line 481 "../src/PlaybackManager.vala"
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
#line 3025 "PlaybackManager.c"
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
#line 482 "../src/PlaybackManager.vala"
				_tmp14_ = self->priv->playbacks;
#line 482 "../src/PlaybackManager.vala"
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 482 "../src/PlaybackManager.vala"
				_playback_it = _tmp15_;
#line 482 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 3039 "PlaybackManager.c"
					GeeIterator* _tmp16_;
					NoisePlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
#line 482 "../src/PlaybackManager.vala"
					_tmp16_ = _playback_it;
#line 482 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 482 "../src/PlaybackManager.vala"
						break;
#line 3050 "PlaybackManager.c"
					}
#line 482 "../src/PlaybackManager.vala"
					_tmp17_ = _playback_it;
#line 482 "../src/PlaybackManager.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 482 "../src/PlaybackManager.vala"
					playback = (NoisePlayback*) _tmp18_;
#line 3058 "PlaybackManager.c"
					{
						GeeIterator* _supported_uri_it = NULL;
						NoisePlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
#line 483 "../src/PlaybackManager.vala"
						_tmp19_ = playback;
#line 483 "../src/PlaybackManager.vala"
						_tmp20_ = noise_playback_get_supported_uri (_tmp19_);
#line 483 "../src/PlaybackManager.vala"
						_tmp21_ = _tmp20_;
#line 483 "../src/PlaybackManager.vala"
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 483 "../src/PlaybackManager.vala"
						_tmp23_ = _tmp22_;
#line 483 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp21_);
#line 483 "../src/PlaybackManager.vala"
						_supported_uri_it = _tmp23_;
#line 483 "../src/PlaybackManager.vala"
						while (TRUE) {
#line 3082 "PlaybackManager.c"
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
#line 483 "../src/PlaybackManager.vala"
							_tmp24_ = _supported_uri_it;
#line 483 "../src/PlaybackManager.vala"
							if (!gee_iterator_next (_tmp24_)) {
#line 483 "../src/PlaybackManager.vala"
								break;
#line 3098 "PlaybackManager.c"
							}
#line 483 "../src/PlaybackManager.vala"
							_tmp25_ = _supported_uri_it;
#line 483 "../src/PlaybackManager.vala"
							_tmp26_ = gee_iterator_get (_tmp25_);
#line 483 "../src/PlaybackManager.vala"
							supported_uri = (gchar*) _tmp26_;
#line 484 "../src/PlaybackManager.vala"
							_tmp27_ = noise_media_get_uri (_data10_->m);
#line 484 "../src/PlaybackManager.vala"
							_tmp28_ = _tmp27_;
#line 484 "../src/PlaybackManager.vala"
							_tmp29_ = _tmp28_;
#line 484 "../src/PlaybackManager.vala"
							_tmp30_ = supported_uri;
#line 484 "../src/PlaybackManager.vala"
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
#line 484 "../src/PlaybackManager.vala"
							_g_free0 (_tmp29_);
#line 484 "../src/PlaybackManager.vala"
							if (_tmp31_) {
#line 3120 "PlaybackManager.c"
								NoisePlayback* _tmp32_;
								NoisePlayback* _tmp33_;
								NoisePlayback* _tmp34_;
								NoisePlayback* _tmp35_;
#line 485 "../src/PlaybackManager.vala"
								_tmp32_ = self->player;
#line 485 "../src/PlaybackManager.vala"
								self->priv->saved_volume = noise_playback_get_volume (_tmp32_);
#line 486 "../src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
#line 487 "../src/PlaybackManager.vala"
								_tmp33_ = self->player;
#line 487 "../src/PlaybackManager.vala"
								noise_playback_set_state (_tmp33_, GST_STATE_NULL);
#line 488 "../src/PlaybackManager.vala"
								found = TRUE;
#line 489 "../src/PlaybackManager.vala"
								_tmp34_ = playback;
#line 489 "../src/PlaybackManager.vala"
								_tmp35_ = _g_object_ref0 (_tmp34_);
#line 489 "../src/PlaybackManager.vala"
								_g_object_unref0 (self->player);
#line 489 "../src/PlaybackManager.vala"
								self->player = _tmp35_;
#line 490 "../src/PlaybackManager.vala"
								noise_playback_manager_set_volume (self, self->priv->saved_volume);
#line 491 "../src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
#line 492 "../src/PlaybackManager.vala"
								_g_free0 (supported_uri);
#line 492 "../src/PlaybackManager.vala"
								break;
#line 3153 "PlaybackManager.c"
							}
#line 483 "../src/PlaybackManager.vala"
							_g_free0 (supported_uri);
#line 3157 "PlaybackManager.c"
						}
#line 483 "../src/PlaybackManager.vala"
						_g_object_unref0 (_supported_uri_it);
#line 3161 "PlaybackManager.c"
					}
#line 495 "../src/PlaybackManager.vala"
					if (found == TRUE) {
#line 496 "../src/PlaybackManager.vala"
						break;
#line 3167 "PlaybackManager.c"
					}
				}
#line 482 "../src/PlaybackManager.vala"
				_g_object_unref0 (_playback_it);
#line 3172 "PlaybackManager.c"
			}
		}
		__finally19:
		{
			GeeTreeSet* _tmp36_;
#line 481 "../src/PlaybackManager.vala"
			_tmp36_ = self->priv->playbacks;
#line 481 "../src/PlaybackManager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
#line 3182 "PlaybackManager.c"
		}
#line 481 "../src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/PlaybackManager.vala"
			block10_data_unref (_data10_);
#line 481 "../src/PlaybackManager.vala"
			_data10_ = NULL;
#line 481 "../src/PlaybackManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 481 "../src/PlaybackManager.vala"
			g_clear_error (&_inner_error0_);
#line 481 "../src/PlaybackManager.vala"
			return;
#line 3196 "PlaybackManager.c"
		}
	}
#line 500 "../src/PlaybackManager.vala"
	if (!found) {
#line 3201 "PlaybackManager.c"
		GThemedIcon* _tmp37_;
		GThemedIcon* _tmp38_;
		NoiseMedia* _tmp39_;
		NoiseMedia* _tmp40_;
#line 501 "../src/PlaybackManager.vala"
		_tmp37_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 501 "../src/PlaybackManager.vala"
		_tmp38_ = _tmp37_;
#line 501 "../src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp38_);
#line 501 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp38_);
#line 502 "../src/PlaybackManager.vala"
		_tmp39_ = noise_playback_manager_get_next (self, TRUE);
#line 502 "../src/PlaybackManager.vala"
		_tmp40_ = _tmp39_;
#line 502 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp40_);
#line 503 "../src/PlaybackManager.vala"
		block10_data_unref (_data10_);
#line 503 "../src/PlaybackManager.vala"
		_data10_ = NULL;
#line 503 "../src/PlaybackManager.vala"
		return;
#line 3226 "PlaybackManager.c"
	}
#line 507 "../src/PlaybackManager.vala"
	_tmp41_ = noise_media_get_file (_data10_->m);
#line 507 "../src/PlaybackManager.vala"
	_tmp42_ = _tmp41_;
#line 507 "../src/PlaybackManager.vala"
	if (!g_file_query_exists (_tmp42_, NULL)) {
#line 3234 "PlaybackManager.c"
		GThemedIcon* _tmp43_;
		GThemedIcon* _tmp44_;
		NoiseMedia* _tmp45_;
		NoiseMedia* _tmp46_;
#line 508 "../src/PlaybackManager.vala"
		_tmp43_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 508 "../src/PlaybackManager.vala"
		_tmp44_ = _tmp43_;
#line 508 "../src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp44_);
#line 508 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp44_);
#line 509 "../src/PlaybackManager.vala"
		noise_media_set_location_unknown (_data10_->m, TRUE);
#line 511 "../src/PlaybackManager.vala"
		_tmp45_ = noise_playback_manager_get_next (self, TRUE);
#line 511 "../src/PlaybackManager.vala"
		_tmp46_ = _tmp45_;
#line 511 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp46_);
#line 512 "../src/PlaybackManager.vala"
		block10_data_unref (_data10_);
#line 512 "../src/PlaybackManager.vala"
		_data10_ = NULL;
#line 512 "../src/PlaybackManager.vala"
		return;
#line 3261 "PlaybackManager.c"
	} else {
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
#line 514 "../src/PlaybackManager.vala"
		_tmp48_ = noise_media_get_location_unknown (_data10_->m);
#line 514 "../src/PlaybackManager.vala"
		_tmp49_ = _tmp48_;
#line 514 "../src/PlaybackManager.vala"
		if (_tmp49_) {
#line 3272 "PlaybackManager.c"
			GIcon* _tmp50_;
			GIcon* _tmp51_;
#line 514 "../src/PlaybackManager.vala"
			_tmp50_ = noise_media_get_unique_status_image (_data10_->m);
#line 514 "../src/PlaybackManager.vala"
			_tmp51_ = _tmp50_;
#line 514 "../src/PlaybackManager.vala"
			_tmp47_ = _tmp51_ != NULL;
#line 3281 "PlaybackManager.c"
		} else {
#line 514 "../src/PlaybackManager.vala"
			_tmp47_ = FALSE;
#line 3285 "PlaybackManager.c"
		}
#line 514 "../src/PlaybackManager.vala"
		if (_tmp47_) {
#line 515 "../src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_data10_->m, NULL);
#line 516 "../src/PlaybackManager.vala"
			noise_media_set_location_unknown (_data10_->m, FALSE);
#line 3293 "PlaybackManager.c"
		}
	}
#line 520 "../src/PlaybackManager.vala"
	noise_playback_manager_change_gains_thread (self);
#line 522 "../src/PlaybackManager.vala"
	_tmp52_ = self->player;
#line 522 "../src/PlaybackManager.vala"
	noise_playback_set_media (_tmp52_, _data10_->m);
#line 525 "../src/PlaybackManager.vala"
	_tmp53_ = self->priv->_playing;
#line 525 "../src/PlaybackManager.vala"
	if (!_tmp53_) {
#line 3306 "PlaybackManager.c"
		NoisePlayback* _tmp54_;
#line 526 "../src/PlaybackManager.vala"
		_tmp54_ = self->player;
#line 526 "../src/PlaybackManager.vala"
		noise_playback_pause (_tmp54_);
#line 3312 "PlaybackManager.c"
	}
#line 530 "../src/PlaybackManager.vala"
	_tmp56_ = noise_media_get_rowid (_data10_->m);
#line 530 "../src/PlaybackManager.vala"
	_tmp57_ = _tmp56_;
#line 530 "../src/PlaybackManager.vala"
	if (_tmp57_ >= ((gint64) 0)) {
#line 3320 "PlaybackManager.c"
		NoiseSettingsMain* _tmp58_;
		NoiseSettingsMain* _tmp59_;
#line 530 "../src/PlaybackManager.vala"
		_tmp58_ = noise_settings_main_get_default ();
#line 530 "../src/PlaybackManager.vala"
		_tmp59_ = _tmp58_;
#line 530 "../src/PlaybackManager.vala"
		_tmp55_ = !noise_settings_main_privacy_mode_enabled (_tmp59_);
#line 530 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp59_);
#line 3331 "PlaybackManager.c"
	} else {
#line 530 "../src/PlaybackManager.vala"
		_tmp55_ = FALSE;
#line 3335 "PlaybackManager.c"
	}
#line 530 "../src/PlaybackManager.vala"
	if (_tmp55_) {
#line 3339 "PlaybackManager.c"
		GSettings* _tmp60_;
		GSettings* _tmp61_;
		gint64 _tmp62_;
		gint64 _tmp63_;
#line 531 "../src/PlaybackManager.vala"
		_tmp60_ = noise_app_get_saved_state ();
#line 531 "../src/PlaybackManager.vala"
		_tmp61_ = _tmp60_;
#line 531 "../src/PlaybackManager.vala"
		_tmp62_ = noise_media_get_rowid (_data10_->m);
#line 531 "../src/PlaybackManager.vala"
		_tmp63_ = _tmp62_;
#line 531 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp61_, "last-media-playing", _tmp63_);
#line 3354 "PlaybackManager.c"
	}
#line 534 "../src/PlaybackManager.vala"
	if (_data10_->m != NULL) {
#line 535 "../src/PlaybackManager.vala"
		g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data10_->m);
#line 3360 "PlaybackManager.c"
	}
#line 539 "../src/PlaybackManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda33__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 458 "../src/PlaybackManager.vala"
	block10_data_unref (_data10_);
#line 458 "../src/PlaybackManager.vala"
	_data10_ = NULL;
#line 3368 "PlaybackManager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 3387 "PlaybackManager.c"
}

void
noise_playback_manager_change_gains_thread (NoisePlaybackManager* self)
{
	NoiseSettingsEqualizer* equalizer_settings = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 557 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 558 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_equalizer_get_default ();
#line 558 "../src/PlaybackManager.vala"
	equalizer_settings = _tmp0_;
#line 559 "../src/PlaybackManager.vala"
	_tmp1_ = equalizer_settings;
#line 559 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_equalizer_get_equalizer_enabled (_tmp1_);
#line 559 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 559 "../src/PlaybackManager.vala"
	if (_tmp3_) {
#line 3412 "PlaybackManager.c"
		gboolean automatic_enabled = FALSE;
		NoiseSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		NoiseSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 560 "../src/PlaybackManager.vala"
		_tmp4_ = equalizer_settings;
#line 560 "../src/PlaybackManager.vala"
		_tmp5_ = noise_settings_equalizer_get_auto_switch_preset (_tmp4_);
#line 560 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 560 "../src/PlaybackManager.vala"
		automatic_enabled = _tmp6_;
#line 561 "../src/PlaybackManager.vala"
		_tmp7_ = equalizer_settings;
#line 561 "../src/PlaybackManager.vala"
		_tmp8_ = noise_settings_equalizer_get_selected_preset (_tmp7_);
#line 561 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 561 "../src/PlaybackManager.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 561 "../src/PlaybackManager.vala"
		selected_preset = _tmp10_;
#line 3440 "PlaybackManager.c"
		{
			GeeIterator* _p_it = NULL;
			NoiseSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
#line 563 "../src/PlaybackManager.vala"
			_tmp11_ = equalizer_settings;
#line 563 "../src/PlaybackManager.vala"
			_tmp12_ = noise_settings_equalizer_get_presets (_tmp11_);
#line 563 "../src/PlaybackManager.vala"
			_tmp13_ = _tmp12_;
#line 563 "../src/PlaybackManager.vala"
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 563 "../src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 563 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp13_);
#line 563 "../src/PlaybackManager.vala"
			_p_it = _tmp15_;
#line 563 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3464 "PlaybackManager.c"
				GeeIterator* _tmp16_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				gboolean _tmp19_ = FALSE;
				NoiseEqualizerPreset* _tmp20_;
#line 563 "../src/PlaybackManager.vala"
				_tmp16_ = _p_it;
#line 563 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp16_)) {
#line 563 "../src/PlaybackManager.vala"
					break;
#line 3477 "PlaybackManager.c"
				}
#line 563 "../src/PlaybackManager.vala"
				_tmp17_ = _p_it;
#line 563 "../src/PlaybackManager.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 563 "../src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp18_;
#line 564 "../src/PlaybackManager.vala"
				_tmp20_ = p;
#line 564 "../src/PlaybackManager.vala"
				if (_tmp20_ != NULL) {
#line 3489 "PlaybackManager.c"
					NoiseMedia* _tmp21_;
#line 564 "../src/PlaybackManager.vala"
					_tmp21_ = self->priv->_current_media;
#line 564 "../src/PlaybackManager.vala"
					_tmp19_ = _tmp21_ != NULL;
#line 3495 "PlaybackManager.c"
				} else {
#line 564 "../src/PlaybackManager.vala"
					_tmp19_ = FALSE;
#line 3499 "PlaybackManager.c"
				}
#line 564 "../src/PlaybackManager.vala"
				if (_tmp19_) {
#line 3503 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean match_genre = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
#line 565 "../src/PlaybackManager.vala"
					_tmp22_ = p;
#line 565 "../src/PlaybackManager.vala"
					_tmp23_ = noise_equalizer_preset_get_name (_tmp22_);
#line 565 "../src/PlaybackManager.vala"
					_tmp24_ = _tmp23_;
#line 565 "../src/PlaybackManager.vala"
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 565 "../src/PlaybackManager.vala"
					preset_name = _tmp25_;
#line 566 "../src/PlaybackManager.vala"
					_tmp26_ = self->priv->_current_media;
#line 566 "../src/PlaybackManager.vala"
					_tmp27_ = noise_media_get_genre (_tmp26_);
#line 566 "../src/PlaybackManager.vala"
					_tmp28_ = _tmp27_;
#line 566 "../src/PlaybackManager.vala"
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
#line 566 "../src/PlaybackManager.vala"
					media_genre = _tmp29_;
#line 568 "../src/PlaybackManager.vala"
					_tmp31_ = media_genre;
#line 568 "../src/PlaybackManager.vala"
					_tmp32_ = preset_name;
#line 568 "../src/PlaybackManager.vala"
					if (string_contains (_tmp31_, _tmp32_)) {
#line 568 "../src/PlaybackManager.vala"
						_tmp30_ = TRUE;
#line 3548 "PlaybackManager.c"
					} else {
						const gchar* _tmp33_;
						const gchar* _tmp34_;
#line 568 "../src/PlaybackManager.vala"
						_tmp33_ = preset_name;
#line 568 "../src/PlaybackManager.vala"
						_tmp34_ = media_genre;
#line 568 "../src/PlaybackManager.vala"
						_tmp30_ = string_contains (_tmp33_, _tmp34_);
#line 3558 "PlaybackManager.c"
					}
#line 568 "../src/PlaybackManager.vala"
					match_genre = _tmp30_;
#line 570 "../src/PlaybackManager.vala"
					if (automatic_enabled) {
#line 570 "../src/PlaybackManager.vala"
						_tmp36_ = match_genre;
#line 3566 "PlaybackManager.c"
					} else {
#line 570 "../src/PlaybackManager.vala"
						_tmp36_ = FALSE;
#line 3570 "PlaybackManager.c"
					}
#line 570 "../src/PlaybackManager.vala"
					if (_tmp36_) {
#line 570 "../src/PlaybackManager.vala"
						_tmp35_ = TRUE;
#line 3576 "PlaybackManager.c"
					} else {
						gboolean _tmp37_ = FALSE;
#line 571 "../src/PlaybackManager.vala"
						if (!automatic_enabled) {
#line 3581 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							const gchar* _tmp41_;
#line 571 "../src/PlaybackManager.vala"
							_tmp38_ = p;
#line 571 "../src/PlaybackManager.vala"
							_tmp39_ = noise_equalizer_preset_get_name (_tmp38_);
#line 571 "../src/PlaybackManager.vala"
							_tmp40_ = _tmp39_;
#line 571 "../src/PlaybackManager.vala"
							_tmp41_ = selected_preset;
#line 571 "../src/PlaybackManager.vala"
							_tmp37_ = g_strcmp0 (_tmp40_, _tmp41_) == 0;
#line 3596 "PlaybackManager.c"
						} else {
#line 571 "../src/PlaybackManager.vala"
							_tmp37_ = FALSE;
#line 3600 "PlaybackManager.c"
						}
#line 571 "../src/PlaybackManager.vala"
						_tmp35_ = _tmp37_;
#line 3604 "PlaybackManager.c"
					}
#line 570 "../src/PlaybackManager.vala"
					if (_tmp35_) {
#line 3608 "PlaybackManager.c"
						{
							gint i = 0;
#line 572 "../src/PlaybackManager.vala"
							i = 0;
#line 3613 "PlaybackManager.c"
							{
								gboolean _tmp42_ = FALSE;
#line 572 "../src/PlaybackManager.vala"
								_tmp42_ = TRUE;
#line 572 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 3620 "PlaybackManager.c"
									NoisePlayback* _tmp44_;
									NoiseEqualizerPreset* _tmp45_;
#line 572 "../src/PlaybackManager.vala"
									if (!_tmp42_) {
#line 3625 "PlaybackManager.c"
										gint _tmp43_;
#line 572 "../src/PlaybackManager.vala"
										_tmp43_ = i;
#line 572 "../src/PlaybackManager.vala"
										i = _tmp43_ + 1;
#line 3631 "PlaybackManager.c"
									}
#line 572 "../src/PlaybackManager.vala"
									_tmp42_ = FALSE;
#line 572 "../src/PlaybackManager.vala"
									if (!(i < 10)) {
#line 572 "../src/PlaybackManager.vala"
										break;
#line 3639 "PlaybackManager.c"
									}
#line 573 "../src/PlaybackManager.vala"
									_tmp44_ = self->player;
#line 573 "../src/PlaybackManager.vala"
									_tmp45_ = p;
#line 573 "../src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp44_, i, noise_equalizer_preset_get_gain (_tmp45_, i));
#line 3647 "PlaybackManager.c"
								}
							}
						}
#line 576 "../src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 576 "../src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 576 "../src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 576 "../src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 576 "../src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 576 "../src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 576 "../src/PlaybackManager.vala"
						return;
#line 3665 "PlaybackManager.c"
					}
#line 564 "../src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 564 "../src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 3671 "PlaybackManager.c"
				}
#line 563 "../src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 3675 "PlaybackManager.c"
			}
#line 563 "../src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 3679 "PlaybackManager.c"
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp46_;
			GeeCollection* _tmp47_;
			GeeIterator* _tmp48_;
			GeeIterator* _tmp49_;
#line 581 "../src/PlaybackManager.vala"
			_tmp46_ = noise_equalizer_get_default_presets ();
#line 581 "../src/PlaybackManager.vala"
			_tmp47_ = _tmp46_;
#line 581 "../src/PlaybackManager.vala"
			_tmp48_ = gee_iterable_iterator ((GeeIterable*) _tmp47_);
#line 581 "../src/PlaybackManager.vala"
			_tmp49_ = _tmp48_;
#line 581 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp47_);
#line 581 "../src/PlaybackManager.vala"
			_p_it = _tmp49_;
#line 581 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3701 "PlaybackManager.c"
				GeeIterator* _tmp50_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp51_;
				gpointer _tmp52_;
				gboolean _tmp53_ = FALSE;
				NoiseEqualizerPreset* _tmp54_;
#line 581 "../src/PlaybackManager.vala"
				_tmp50_ = _p_it;
#line 581 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp50_)) {
#line 581 "../src/PlaybackManager.vala"
					break;
#line 3714 "PlaybackManager.c"
				}
#line 581 "../src/PlaybackManager.vala"
				_tmp51_ = _p_it;
#line 581 "../src/PlaybackManager.vala"
				_tmp52_ = gee_iterator_get (_tmp51_);
#line 581 "../src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp52_;
#line 582 "../src/PlaybackManager.vala"
				_tmp54_ = p;
#line 582 "../src/PlaybackManager.vala"
				if (_tmp54_ != NULL) {
#line 3726 "PlaybackManager.c"
					NoiseMedia* _tmp55_;
#line 582 "../src/PlaybackManager.vala"
					_tmp55_ = self->priv->_current_media;
#line 582 "../src/PlaybackManager.vala"
					_tmp53_ = _tmp55_ != NULL;
#line 3732 "PlaybackManager.c"
				} else {
#line 582 "../src/PlaybackManager.vala"
					_tmp53_ = FALSE;
#line 3736 "PlaybackManager.c"
				}
#line 582 "../src/PlaybackManager.vala"
				if (_tmp53_) {
#line 3740 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp56_;
					const gchar* _tmp57_;
					const gchar* _tmp58_;
					gchar* _tmp59_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp60_;
					const gchar* _tmp61_;
					const gchar* _tmp62_;
					gchar* _tmp63_;
					gboolean _tmp64_ = FALSE;
					const gchar* _tmp65_;
					const gchar* _tmp66_;
					gboolean match_genre = FALSE;
					gboolean _tmp69_ = FALSE;
					gboolean _tmp70_ = FALSE;
#line 583 "../src/PlaybackManager.vala"
					_tmp56_ = p;
#line 583 "../src/PlaybackManager.vala"
					_tmp57_ = noise_equalizer_preset_get_name (_tmp56_);
#line 583 "../src/PlaybackManager.vala"
					_tmp58_ = _tmp57_;
#line 583 "../src/PlaybackManager.vala"
					_tmp59_ = g_utf8_strdown (_tmp58_, (gssize) -1);
#line 583 "../src/PlaybackManager.vala"
					preset_name = _tmp59_;
#line 584 "../src/PlaybackManager.vala"
					_tmp60_ = self->priv->_current_media;
#line 584 "../src/PlaybackManager.vala"
					_tmp61_ = noise_media_get_genre (_tmp60_);
#line 584 "../src/PlaybackManager.vala"
					_tmp62_ = _tmp61_;
#line 584 "../src/PlaybackManager.vala"
					_tmp63_ = g_utf8_strdown (_tmp62_, (gssize) -1);
#line 584 "../src/PlaybackManager.vala"
					media_genre = _tmp63_;
#line 586 "../src/PlaybackManager.vala"
					_tmp65_ = media_genre;
#line 586 "../src/PlaybackManager.vala"
					_tmp66_ = preset_name;
#line 586 "../src/PlaybackManager.vala"
					if (string_contains (_tmp65_, _tmp66_)) {
#line 586 "../src/PlaybackManager.vala"
						_tmp64_ = TRUE;
#line 3785 "PlaybackManager.c"
					} else {
						const gchar* _tmp67_;
						const gchar* _tmp68_;
#line 586 "../src/PlaybackManager.vala"
						_tmp67_ = preset_name;
#line 586 "../src/PlaybackManager.vala"
						_tmp68_ = media_genre;
#line 586 "../src/PlaybackManager.vala"
						_tmp64_ = string_contains (_tmp67_, _tmp68_);
#line 3795 "PlaybackManager.c"
					}
#line 586 "../src/PlaybackManager.vala"
					match_genre = _tmp64_;
#line 588 "../src/PlaybackManager.vala"
					if (automatic_enabled) {
#line 588 "../src/PlaybackManager.vala"
						_tmp70_ = match_genre;
#line 3803 "PlaybackManager.c"
					} else {
#line 588 "../src/PlaybackManager.vala"
						_tmp70_ = FALSE;
#line 3807 "PlaybackManager.c"
					}
#line 588 "../src/PlaybackManager.vala"
					if (_tmp70_) {
#line 588 "../src/PlaybackManager.vala"
						_tmp69_ = TRUE;
#line 3813 "PlaybackManager.c"
					} else {
						gboolean _tmp71_ = FALSE;
#line 589 "../src/PlaybackManager.vala"
						if (!automatic_enabled) {
#line 3818 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp72_;
							const gchar* _tmp73_;
							const gchar* _tmp74_;
							const gchar* _tmp75_;
#line 589 "../src/PlaybackManager.vala"
							_tmp72_ = p;
#line 589 "../src/PlaybackManager.vala"
							_tmp73_ = noise_equalizer_preset_get_name (_tmp72_);
#line 589 "../src/PlaybackManager.vala"
							_tmp74_ = _tmp73_;
#line 589 "../src/PlaybackManager.vala"
							_tmp75_ = selected_preset;
#line 589 "../src/PlaybackManager.vala"
							_tmp71_ = g_strcmp0 (_tmp74_, _tmp75_) == 0;
#line 3833 "PlaybackManager.c"
						} else {
#line 589 "../src/PlaybackManager.vala"
							_tmp71_ = FALSE;
#line 3837 "PlaybackManager.c"
						}
#line 589 "../src/PlaybackManager.vala"
						_tmp69_ = _tmp71_;
#line 3841 "PlaybackManager.c"
					}
#line 588 "../src/PlaybackManager.vala"
					if (_tmp69_) {
#line 3845 "PlaybackManager.c"
						{
							gint i = 0;
#line 590 "../src/PlaybackManager.vala"
							i = 0;
#line 3850 "PlaybackManager.c"
							{
								gboolean _tmp76_ = FALSE;
#line 590 "../src/PlaybackManager.vala"
								_tmp76_ = TRUE;
#line 590 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 3857 "PlaybackManager.c"
									NoisePlayback* _tmp78_;
									NoiseEqualizerPreset* _tmp79_;
#line 590 "../src/PlaybackManager.vala"
									if (!_tmp76_) {
#line 3862 "PlaybackManager.c"
										gint _tmp77_;
#line 590 "../src/PlaybackManager.vala"
										_tmp77_ = i;
#line 590 "../src/PlaybackManager.vala"
										i = _tmp77_ + 1;
#line 3868 "PlaybackManager.c"
									}
#line 590 "../src/PlaybackManager.vala"
									_tmp76_ = FALSE;
#line 590 "../src/PlaybackManager.vala"
									if (!(i < 10)) {
#line 590 "../src/PlaybackManager.vala"
										break;
#line 3876 "PlaybackManager.c"
									}
#line 591 "../src/PlaybackManager.vala"
									_tmp78_ = self->player;
#line 591 "../src/PlaybackManager.vala"
									_tmp79_ = p;
#line 591 "../src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp78_, i, noise_equalizer_preset_get_gain (_tmp79_, i));
#line 3884 "PlaybackManager.c"
								}
							}
						}
#line 594 "../src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 594 "../src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 594 "../src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 594 "../src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 594 "../src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 594 "../src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 594 "../src/PlaybackManager.vala"
						return;
#line 3902 "PlaybackManager.c"
					}
#line 582 "../src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 582 "../src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 3908 "PlaybackManager.c"
				}
#line 581 "../src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 3912 "PlaybackManager.c"
			}
#line 581 "../src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 3916 "PlaybackManager.c"
		}
#line 559 "../src/PlaybackManager.vala"
		_g_free0 (selected_preset);
#line 3920 "PlaybackManager.c"
	}
	{
		gint i = 0;
#line 600 "../src/PlaybackManager.vala"
		i = 0;
#line 3926 "PlaybackManager.c"
		{
			gboolean _tmp80_ = FALSE;
#line 600 "../src/PlaybackManager.vala"
			_tmp80_ = TRUE;
#line 600 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3933 "PlaybackManager.c"
				NoisePlayback* _tmp81_;
#line 600 "../src/PlaybackManager.vala"
				if (!_tmp80_) {
#line 600 "../src/PlaybackManager.vala"
					i = i + 1;
#line 3939 "PlaybackManager.c"
				}
#line 600 "../src/PlaybackManager.vala"
				_tmp80_ = FALSE;
#line 600 "../src/PlaybackManager.vala"
				if (!(i < 10)) {
#line 600 "../src/PlaybackManager.vala"
					break;
#line 3947 "PlaybackManager.c"
				}
#line 601 "../src/PlaybackManager.vala"
				_tmp81_ = self->player;
#line 601 "../src/PlaybackManager.vala"
				noise_playback_set_equalizer_gain (_tmp81_, i, 0);
#line 3953 "PlaybackManager.c"
			}
		}
	}
#line 557 "../src/PlaybackManager.vala"
	_g_object_unref0 (equalizer_settings);
#line 3959 "PlaybackManager.c"
}

void
noise_playback_manager_stop_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	gint64 was_playing = 0LL;
	NoiseMedia* _tmp1_;
	NoiseSettingsMain* _tmp5_;
	NoiseSettingsMain* _tmp6_;
	gboolean _tmp7_;
#line 605 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 606 "../src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 607 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 609 "../src/PlaybackManager.vala"
	was_playing = (gint64) 0;
#line 610 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 610 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 3985 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 611 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 611 "../src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 611 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 611 "../src/PlaybackManager.vala"
		was_playing = _tmp4_;
#line 3997 "PlaybackManager.c"
	}
#line 614 "../src/PlaybackManager.vala"
	_tmp5_ = noise_settings_main_get_default ();
#line 614 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 614 "../src/PlaybackManager.vala"
	_tmp7_ = !noise_settings_main_privacy_mode_enabled (_tmp6_);
#line 614 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp6_);
#line 614 "../src/PlaybackManager.vala"
	if (_tmp7_) {
#line 4009 "PlaybackManager.c"
		GSettings* _tmp8_;
		GSettings* _tmp9_;
#line 615 "../src/PlaybackManager.vala"
		_tmp8_ = noise_app_get_saved_state ();
#line 615 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 615 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
#line 4018 "PlaybackManager.c"
	}
#line 617 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, NULL);
#line 619 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, was_playing);
#line 4024 "PlaybackManager.c"
}

static GVariant*
_variant_new4 (gboolean value)
{
#line 625 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4032 "PlaybackManager.c"
}

void
noise_playback_manager_start_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
#line 622 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 623 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 623 "../src/PlaybackManager.vala"
	noise_playback_play (_tmp0_);
#line 624 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, TRUE);
#line 625 "../src/PlaybackManager.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 625 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 625 "../src/PlaybackManager.vala"
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
#line 625 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 625 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
#line 625 "../src/PlaybackManager.vala"
	_tmp6_ = _variant_new4 (TRUE);
#line 625 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 625 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp6_);
#line 626 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
#line 4071 "PlaybackManager.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 632 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4079 "PlaybackManager.c"
}

void
noise_playback_manager_pause_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
#line 629 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 630 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 630 "../src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 631 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 632 "../src/PlaybackManager.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 632 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 632 "../src/PlaybackManager.vala"
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
#line 632 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 632 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
#line 632 "../src/PlaybackManager.vala"
	_tmp6_ = _variant_new5 (FALSE);
#line 632 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 632 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp6_);
#line 633 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL], 0);
#line 4118 "PlaybackManager.c"
}

NoisePlaybackManager*
noise_playback_manager_construct (GType object_type)
{
	NoisePlaybackManager * self = NULL;
#line 35 "../src/PlaybackManager.vala"
	self = (NoisePlaybackManager*) g_object_new (object_type, NULL);
#line 35 "../src/PlaybackManager.vala"
	return self;
#line 4129 "PlaybackManager.c"
}

NoisePlaybackManager*
noise_playback_manager_new (void)
{
#line 35 "../src/PlaybackManager.vala"
	return noise_playback_manager_construct (NOISE_TYPE_PLAYBACK_MANAGER);
#line 4137 "PlaybackManager.c"
}

static NoiseLibrary*
noise_playback_manager_get_library (NoisePlaybackManager* self)
{
	NoiseLibrary* result;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 60 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/PlaybackManager.vala"
	_tmp0_ = noise_libraries_manager;
#line 60 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_->local_library;
#line 60 "../src/PlaybackManager.vala"
	result = _tmp1_;
#line 60 "../src/PlaybackManager.vala"
	return result;
#line 4156 "PlaybackManager.c"
}

gint
noise_playback_manager_get_current_index (NoisePlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 64 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 65 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 65 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 66 "../src/PlaybackManager.vala"
		result = self->priv->_current_index;
#line 66 "../src/PlaybackManager.vala"
		return result;
#line 4180 "PlaybackManager.c"
	} else {
#line 68 "../src/PlaybackManager.vala"
		result = self->priv->_current_shuffled_index;
#line 68 "../src/PlaybackManager.vala"
		return result;
#line 4186 "PlaybackManager.c"
	}
}

void
noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 71 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:72: Current index: %d", value);
#line 73 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 73 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 73 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 74 "../src/PlaybackManager.vala"
		self->priv->_current_index = value;
#line 4211 "PlaybackManager.c"
	} else {
#line 76 "../src/PlaybackManager.vala"
		self->priv->_current_shuffled_index = value;
#line 4215 "PlaybackManager.c"
	}
#line 71 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
#line 4219 "PlaybackManager.c"
}

gboolean
noise_playback_manager_get_playing (NoisePlaybackManager* self)
{
	gboolean result;
#line 83 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../src/PlaybackManager.vala"
	result = self->priv->_playing;
#line 83 "../src/PlaybackManager.vala"
	return result;
#line 4232 "PlaybackManager.c"
}

static void
noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                    gboolean value)
{
#line 83 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/PlaybackManager.vala"
	if (noise_playback_manager_get_playing (self) != value) {
#line 83 "../src/PlaybackManager.vala"
		self->priv->_playing = value;
#line 83 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
#line 4247 "PlaybackManager.c"
	}
}

gdouble
noise_playback_manager_get_volume (NoisePlaybackManager* self)
{
	gdouble result;
	NoisePlayback* _tmp0_;
#line 87 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 88 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 88 "../src/PlaybackManager.vala"
	result = noise_playback_get_volume (_tmp0_);
#line 88 "../src/PlaybackManager.vala"
	return result;
#line 4264 "PlaybackManager.c"
}

void
noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                   gdouble value)
{
	NoisePlayback* _tmp0_;
#line 90 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/PlaybackManager.vala"
	self->priv->saved_volume = value;
#line 92 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 92 "../src/PlaybackManager.vala"
	noise_playback_set_volume (_tmp0_, value);
#line 90 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
#line 4282 "PlaybackManager.c"
}

NoiseMedia*
noise_playback_manager_get_current_media (NoisePlaybackManager* self)
{
	NoiseMedia* result;
	NoiseMedia* _tmp0_;
#line 100 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_media;
#line 100 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 100 "../src/PlaybackManager.vala"
	return result;
#line 4298 "PlaybackManager.c"
}

static void
noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                          NoiseMedia* value)
{
#line 100 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/PlaybackManager.vala"
	if (noise_playback_manager_get_current_media (self) != value) {
#line 4309 "PlaybackManager.c"
		NoiseMedia* _tmp0_;
#line 100 "../src/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 100 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_current_media);
#line 100 "../src/PlaybackManager.vala"
		self->priv->_current_media = _tmp0_;
#line 100 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
#line 4319 "PlaybackManager.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 35 "../src/PlaybackManager.vala"
	g_return_if_fail (n_param_values == 2);
#line 35 "../src/PlaybackManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 35 "../src/PlaybackManager.vala"
		data1 = closure->data;
#line 35 "../src/PlaybackManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 4345 "PlaybackManager.c"
	} else {
#line 35 "../src/PlaybackManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 35 "../src/PlaybackManager.vala"
		data2 = closure->data;
#line 4351 "PlaybackManager.c"
	}
#line 35 "../src/PlaybackManager.vala"
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
#line 35 "../src/PlaybackManager.vala"
	callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 4357 "PlaybackManager.c"
}

static GObject *
noise_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlaybackManager * self;
	NoiseHistoryPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	NoiseStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	NoiseStreamer* _tmp10_;
	NoiseStreamer* _tmp11_;
	NoisePlayback* _tmp12_;
#line 102 "../src/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (noise_playback_manager_parent_class);
#line 102 "../src/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 102 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 103 "../src/PlaybackManager.vala"
	_tmp0_ = noise_history_playlist_new ();
#line 103 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 103 "../src/PlaybackManager.vala"
	self->history_playlist = _tmp0_;
#line 104 "../src/PlaybackManager.vala"
	_tmp1_ = noise_static_playlist_new ();
#line 104 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 104 "../src/PlaybackManager.vala"
	self->queue_playlist = _tmp1_;
#line 105 "../src/PlaybackManager.vala"
	_tmp2_ = self->queue_playlist;
#line 105 "../src/PlaybackManager.vala"
	noise_playlist_set_name ((NoisePlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
#line 106 "../src/PlaybackManager.vala"
	_tmp3_ = self->queue_playlist;
#line 106 "../src/PlaybackManager.vala"
	noise_static_playlist_set_read_only (_tmp3_, TRUE);
#line 107 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 107 "../src/PlaybackManager.vala"
	noise_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
#line 108 "../src/PlaybackManager.vala"
	_tmp5_ = self->queue_playlist;
#line 108 "../src/PlaybackManager.vala"
	noise_static_playlist_set_show_badge (_tmp5_, TRUE);
#line 109 "../src/PlaybackManager.vala"
	_tmp6_ = self->queue_playlist;
#line 109 "../src/PlaybackManager.vala"
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 109 "../src/PlaybackManager.vala"
	_g_object_unref0 (((NoisePlaylist*) _tmp6_)->icon);
#line 109 "../src/PlaybackManager.vala"
	((NoisePlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
#line 111 "../src/PlaybackManager.vala"
	_tmp8_ = noise_streamer_new ();
#line 111 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 111 "../src/PlaybackManager.vala"
	self->file_player = _tmp8_;
#line 112 "../src/PlaybackManager.vala"
	_tmp9_ = self->priv->playbacks;
#line 112 "../src/PlaybackManager.vala"
	_tmp10_ = self->file_player;
#line 112 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (NoisePlayback*) _tmp10_);
#line 113 "../src/PlaybackManager.vala"
	_tmp11_ = self->file_player;
#line 113 "../src/PlaybackManager.vala"
	_tmp12_ = _g_object_ref0 ((NoisePlayback*) _tmp11_);
#line 113 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 113 "../src/PlaybackManager.vala"
	self->player = _tmp12_;
#line 102 "../src/PlaybackManager.vala"
	return obj;
#line 4445 "PlaybackManager.c"
}

static void
noise_playback_manager_class_init (NoisePlaybackManagerClass * klass,
                                   gpointer klass_data)
{
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/PlaybackManager.vala"
	g_type_class_adjust_private_offset (klass, &NoisePlaybackManager_private_offset);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playback_manager_get_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playback_manager_set_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_playback_manager_constructor;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_playback_manager_finalize;
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", NOISE_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL] = g_signal_new ("playback-paused", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4486 "PlaybackManager.c"
}

static void
noise_playback_manager_instance_init (NoisePlaybackManager * self,
                                      gpointer klass)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 35 "../src/PlaybackManager.vala"
	self->priv = noise_playback_manager_get_instance_private (self);
#line 48 "../src/PlaybackManager.vala"
	g_rec_mutex_init (&self->priv->__lock_playbacks);
#line 48 "../src/PlaybackManager.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/PlaybackManager.vala"
	self->priv->playbacks = _tmp0_;
#line 51 "../src/PlaybackManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "../src/PlaybackManager.vala"
	self->priv->_current = _tmp1_;
#line 54 "../src/PlaybackManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled = _tmp2_;
#line 83 "../src/PlaybackManager.vala"
	self->priv->_playing = FALSE;
#line 85 "../src/PlaybackManager.vala"
	self->priv->saved_volume = (gdouble) 1;
#line 4516 "PlaybackManager.c"
}

static void
noise_playback_manager_finalize (GObject * obj)
{
	NoisePlaybackManager * self;
#line 35 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 48 "../src/PlaybackManager.vala"
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
#line 48 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbacks);
#line 51 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current);
#line 54 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_shuffled);
#line 56 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 57 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 98 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 99 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 100 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_media);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (noise_playback_manager_parent_class)->finalize (obj);
#line 4545 "PlaybackManager.c"
}

/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Noise.Playback} to play a media
*/
GType
noise_playback_manager_get_type (void)
{
	static volatile gsize noise_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaybackManager), 0, (GInstanceInitFunc) noise_playback_manager_instance_init, NULL };
		GType noise_playback_manager_type_id;
		noise_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaybackManager", &g_define_type_info, 0);
		NoisePlaybackManager_private_offset = g_type_add_instance_private (noise_playback_manager_type_id, sizeof (NoisePlaybackManagerPrivate));
		g_once_init_leave (&noise_playback_manager_type_id__volatile, noise_playback_manager_type_id);
	}
	return noise_playback_manager_type_id__volatile;
}

static void
_vala_noise_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_int (value, noise_playback_manager_get_current_index (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_boolean (value, noise_playback_manager_get_playing (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_double (value, noise_playback_manager_get_volume (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_object (value, noise_playback_manager_get_current_media (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4601 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4607 "PlaybackManager.c"
	}
}

static void
_vala_noise_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_current_index (self, g_value_get_int (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_playing (self, g_value_get_boolean (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_volume (self, g_value_get_double (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_current_media (self, g_value_get_object (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4645 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4651 "PlaybackManager.c"
	}
}

